<%--
 *
 * IBM Confidential
 *
 * OCO Source Materials
 *
 * 5724-M19
 *
 * (C) COPYRIGHT IBM CORP. 2006
 *
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 *
--%>
<%@ include file="../common/componentheader.jsp" %>
<%
	String message = component.getProperty("message");
	String messageKey = component.getProperty("messagekey");
	String messageGroup = component.getProperty("messagegroup");	
	String doneMessage = component.getProperty("donemessage");
	String doneMessagekey = component.getProperty("donemessagekey");
	String doneMessageGroup = component.getProperty("donemessagegroup");	
	String progressImage = component.getProperty("progressimage");
	String progressDoneImage = component.getProperty("progressdoneimage");
	String longOpMessage = component.getProperty("longopmessage");
	String isfromquery = component.getProperty("isfromquery");
	int cut = -1;
	if(!WebClientRuntime.isNull(longOpMessage))
		cut=longOpMessage.indexOf("#");
	if(cut>-1)
	{
		messageGroup=longOpMessage.substring(0,cut);
		messageKey=longOpMessage.substring(cut+1);
	}
	boolean realtimeMessages = Boolean.valueOf(component.getProperty("showmessages")).booleanValue();
	String messages = "";
	String interval = component.getProperty("interval");
	if(WebClientRuntime.isNull(interval))
		interval = "4000";
	
	// If no explicit message specified on the control, use the default keys
	if(WebClientRuntime.isNull(message) || !WebClientRuntime.isNull(longOpMessage))
		message = wcs.getMessage(messageGroup,messageKey);

	if(WebClientRuntime.isNull(doneMessage))
	{
		if(!WebClientRuntime.isNull(doneMessagekey) && !WebClientRuntime.isNull(doneMessageGroup))
			doneMessage = wcs.getMessage(doneMessageGroup,doneMessagekey);
	}
	if(component.needsRender())
	{
		String msgAutoId="";
		String imageAutoId="";
		String msgsAutoId="";
		if(automation) {
			msgAutoId="automationid=\""+realId+"_message\"";
			imageAutoId="automationid=\""+realId+"_image\"";
			msgsAutoId="automationid=\""+realId+"_messages\"";
		}
		
		wcs.setLongOpComponent(component);	%>
		<table id="<%=id%>" <%=automationId%> class="longop <%=cssclass%>" >
			<tr>
				<td class="lom" id="<%=id%>_message" <%=msgAutoId%>>
					<%=message %>
				</td>
			</tr>
			<tr>
				<td>
					<img id="<%=id%>_image" <%=imageAutoId%> src="<%= IMAGE_PATH + progressImage%>" alt=""/>
				</td>
			</tr>
		<%	if(realtimeMessages)
			{	%>
			<tr>
				<td align="center">
					<div id="<%= id %>_messages" <%=msgsAutoId%> class="lmb">
					</div>
				</td>
			</tr>
		<%	}	 %>
		</div>
<%		// Must not fire the check events in design mode
		if((!designmode) && isfromquery.equals("false"))
		{	%>		
			<script>
				MAINDOC.addTimeout("dolongopcheck()",<%=Integer.parseInt(interval)%>);
			</script>		 
<%		}
              if((!designmode) && isfromquery.equals("true"))
		{	%>		
			<script>
				MAINDOC.addQueryTimeout("dolongopquerycheck()",<%=Integer.parseInt(interval)%>);
			</script>		 
<%		}
	}
	else if(!designmode)
	{
		if(wcs.hasWarnings())
		{	%>
			el=MAINDOC.getElement("<%=id%>_messages");
			if(el)
			{
		<%		ArrayList messageList = wcs.getWarnings();
				// now add them to the event
				String nextMessage = "";
				for(int i=0;i<messageList.size();i++)
				{	
					nextMessage = WebClientRuntime.replaceString(wcs.getMessage((MXException)messageList.get(i)),"\n\t","<br>"); %>
					oldHTML=el.innerHTML;
					el.innerHTML=oldHTML+"<%=nextMessage%><br><br>";
					el.scrollTop=el.scrollHeight;
		<%		}	
				messageList.clear(); %>
			}
	<%	}
		if(!currentPage.getProperty("buttonsenabled").equals("true"))
		{	%>
			MAINDOC.addTimeout("dolongopcheck()",<%=Integer.parseInt(interval)%>);
	<%	}
		else
		{	
			if(!WebClientRuntime.isNull(doneMessage))
			{	%>
			el=MAINDOC.getElement("<%=id%>_message");
			if(el)
				el.innerHTML="<%=doneMessage%>";
		<%	}
			if(!WebClientRuntime.isNull(progressDoneImage))
			{	%>
			el=MAINDOC.getElement("<%=id%>_image");
			if(el)
				el.src="<%=IMAGE_PATH +progressDoneImage%>";
		<%	}
		}
	}	%>
<%@ include file="../common/componentfooter.jsp" %>
