/*
 *
 * IBM Confidential
 *
 * OCO Source Materials
 *
 * 5724-R46
 *
 * (C) COPYRIGHT IBM CORP. 2006,2007
 *
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 *
 */
var movingItem = null;
var modelessTopZ = 10000;
var modalTopZ = 10000;
var openMenus = new Array();
var highlightid = "";
var highlighttitle = "";
var TIMED_WAIT = false;

var lastClickElement = null;
var lastUniqueMenu = "";
var waitLocked = false;
var currentMenu = null;
var currentMenuItemList = new Array();
var currentMenuItem = null;
var currentTimerId = null;
var currentQueryId = null;
var itemMoveClass = "opacity_70";
var waitOn = true;
var dialogCount = 0;
var objsHidden = false;
var working = true;
var tableHotkeys = new Array();
var rerenderedItems = new Array();
var passwordFields = new Array();
var CANVASID = "";
tableHotkeys[KEYCODE_UP_ARROW]     = new Array(true, false, "previousrow");
tableHotkeys[KEYCODE_DOWN_ARROW]   = new Array(true, false, "nextrow");
tableHotkeys[KEYCODE_LEFT_ARROW]   = new Array(true, false, "previouspage");
tableHotkeys[KEYCODE_RIGHT_ARROW]  = new Array(true, false, "nextpage");
tableHotkeys[KEYCODE_Z]            = new Array(true, false, "togglefilter");
var logfile = "c:\\temp\\MAXIMO_JS_Log.txt";
var clickX, clickY;
var stopFocus = false;
var FADE_VALUE = 100;
var FADE_SPEED = 1;
var menuWorking = false;
var	sendEventDate=new Date();
var moveRestrict = null;
var messageTimeout = null;
var showingPopup = false;
var popupCount=0;
var tableRowEnterKeyFlag = 0;

function funcname(f)
{
    var s = f.toString().match(/function (\w*)/)[1];
    args = f.arguments;
    if(args.length > 0)
    {
        s += "(";
        for(i = 0; i < args.length; i ++ )
        {
            if(i > 0)
	            s += ",";
            s += "'"+args[i]+"'";
        }
        s += ")";
    }
    if ((s == null) || (s.length == 0))
    {
        return "anonymous";
    }
    return "&nbsp;&nbsp;" + s;
}

// This function returns a string that contains a "stack trace."
function stacktrace()
{
    var s = "";
    // This is the string we'll return.
    // Loop through the stack of functions, using the caller property of
    // one arguments object to refer to the next arguments object on the
    // stack.
    for(var a = arguments.caller; a != null; a = a.caller)
    {
        // Add the name of the current function to the return value.
        s += funcname(a.callee) + "<br>";
        // Because of a bug in Navigator 4.0, we need this line to break.
        // a.caller will equal a rather than null when we reach the end
        // of the stack. The following line works around this.
        if (a.caller == a)
        break;
    }
    log = getElement("stackTrace");
    if(log)
    {
        x = log.innerHTML;
        log.innerHTML = x + s + "<hr>";
    }

    //  return s;
}

function getHFElement(id)
{
    if(MAINDOC == parent)
    	return document.getElementsById(id);
    else
    	return HIDDENDOC.getElementById(id);
}

function getElement(id)
{
    if(MAINDOC == parent)
    	return MAINDOC.document.getElementById(id);
    else
    	return MAINDOC.getElementById(id);
}

function submitHidden()
{
    hiddenForm = getHiddenForm();
    if(hiddenForm)
    {
        inputs = hiddenForm.elements;
        if(inputs.namedItem("event").value == "" || inputs.namedItem("targetid").value == "")
        	alert("Event and Target are required!");
        else
        	hiddenForm.submit();
    }
}

function getHiddenForm()
{
    hiddenForm = null;
    if(HIDDENDOC)
    	hiddenForm = HIDDENDOC.getElementById("hiddenform");
    if(!hiddenForm)
    	window.status = "Error: Hidden Form Missing!";
    return hiddenForm;
}


function setCommInput(id,value)
{
    if(working)
    	return;
    val = value;
    // if(undef(val))
    // val = "";
    commframedoc = getElement("commframe").contentWindow.document;
    hiddenForm = commframedoc.getElementById("hiddenform");
    inputs = hiddenForm.elements;
    try
    {
	    inputs.namedItem(id).value = value;
	}
	catch(error)
	{
		alert("did not set! :"+id)
	}

}


function addCommInput(name, value)
{
    if(working)
	  	return;
    val = value;
    // if(undef(val))
    // val = "";
    commframedoc = getElement("commframe").contentWindow.document;
    hiddenForm = commframedoc.getElementById("hiddenform");
    newInput = commframedoc.createElement("input");
    newInput.setAttribute("type","hidden");
    newInput.setAttribute("name",name);
    newInput.setAttribute("value",val);
    hiddenForm.appendChild(newInput);
}


function sendEvent(eventtype, targetid, value)
{
	sendEventDate=new Date();
    if(working)
    	return;
    /* Test whether the target is not disabled */
    var el = getElement(targetid);
    if(!canClick(el))
    	return;
    working=true;
    showWait();
    if(eventtype!="longopcheck")
		focusWait();
    closeMenus();
    hiddenForm = getHiddenForm();
    if(!hiddenForm)
    {
        alert("Error: Hidden Form Missing. Could not send event [" + eventtype + "]!");
        hideWait();
        working=false;
        return;
    }
    inputs = hiddenForm.elements;

    if(eventtype != null)
	    inputs.namedItem("event").value = eventtype;

    if(targetid != null)
	    inputs.namedItem("targetid").value = targetid;
    if(value != null)
	    inputs.namedItem("value").value = value;
    else
    {
        valueInput = inputs.namedItem("value");
        valueInputParent = valueInput.parentNode;
        valueInputParent.removeChild(valueInput);
    }
    ccId = inputs.namedItem("changedcomponentid").value;
    ccVal = inputs.namedItem("changedcomponentvalue").value;
    cfId = inputs.namedItem("currentfocus").value;
    if(!undef(MAINDOC.body))
    {
	    inputs.namedItem("scrolltoppos").value = MAINDOC.body.scrollTop;
   		inputs.namedItem("scrollleftpos").value = MAINDOC.body.scrollLeft;
   	}
    logEvent(eventtype, targetid, value, ccId, ccVal, cfId);
    if(DEBUGLEVEL>=5)
    {
	    if(DEBUGLEVEL>=7)
    		window.status="Waiting to submit";
    	else
    		window.setTimeout("submitHidden()",3000);
    }
    else
    {
    	//had to delay submit for dialog cancel on Mozilla
    	//Strange that with a minimal delay it works 07-24320
	    submitHiddenDelay();
	}
}

function submitHiddenDelay()
{
	window.setTimeout(submitHidden,10);
}

function submitHidden()
{
    hiddenForm = getHiddenForm();
    if(hiddenForm)
		hiddenForm.submit();
}

function logString(stringVal)
{
    log = getHFElement("eventlog");
    if(log)
    {
        x = log.innerHTML;
        log.innerHTML = stringVal + "<br>" + x;
        elInput = getHFElement("eventloginput");
        elInput.innerText=log.innerHTML;
    }
}

function logEvent(eventtype, targetid, value, ccId, ccVal, cfId)
{
    if(value == undefined)
	    value = '';
    log = getHFElement("eventlog");
    if(log)
    {
        x = log.innerHTML;
        log.innerHTML = "sendEvent('<b style='color:#B50501;' title='event'>"+eventtype+"</b>','<b style='color:#336699;cursor:pointer;text-decoration:underline;' onclick='MAINDOC.logHighlight(\""+targetid+"\")' title='target'>"+targetid+"</b>','<b style='color:#B50501;' title='value'>"+value+"</b>','<b style='color:#336699;cursor:pointer;text-decoration:underline;' onclick='logHighlight(\""+ccId+"\")' title='changed field'>"+ccId+"</b>','<b style='color:#B50501;' title='changed field value'>"+ccVal+"</b>','<b style='color:#336699;cursor:pointer;text-decoration:underline;' onclick='logHighlight(\""+cfId+"\")' title='focus field'>"+cfId+"</b>')<br>" + x;
        elInput = getHFElement("eventloginput");
        elInput.innerText=log.innerHTML;
    }
}

function logHighlight(id, title)
{
    if(id==highlightid)
	    return;

    if(highlightid != "")
    {
        oldH = getElement(highlightid);
        if(oldH)
        {
            oldH.title = highlighttitle;
            removeClass(oldH, "loghighlight");
            removeClass(oldH, "loghighlight_img");
        }
    }
    if(id != "")
    {
        newH = getElement(id);
        if(newH)
        {
            highlighttitle = newH.title;
            newH.title = id;
            if(newH.tagName == "IMG")
            	appendClass(newH, "loghighlight_img");
            else
            	appendClass(newH, "loghighlight");
        }
    }
    highlightid = id;

}

/* fixes issues where nextSibling returns invalid items */
function getNextSibling(component)
{
    el = component.nextSibling;
    while(el!=null && (undef(el.nodeType) || el.nodeType!=3))
    {
        el = el.nextSibling;
	}
    return el;
}

function input_forceChanged(component)
{
    if(undef(component) || component.readOnly == true)
   		return;
    hiddenForm = getHiddenForm();
    inputs = hiddenForm.elements;
    inputs.namedItem("changedcomponentid").value = component.id;
    inputs.namedItem("changedcomponentvalue").value = component.value;
	inputs.namedItem("vischangedcomponentvalue").value = component.value;
    component.setAttribute("changed", true);
}

function input_changed(event, component)
{
	srcEl = getSourceElement(event);
	if(!undef(srcEl))
	{
		ch=srcEl.getAttribute("changed");
		if(event.keyCode==229) //bad keycode of non-key event sent to fields when using korean IME
		{
			if(undef(ch))
				return false;
		}
	}

    if(event != null)
    {
        showFieldHelp(event, component);
        if(hasKeyCode(event, 'KEYCODE_ALT|KEYCODE_SHIFT|KEYCODE_TAB|KEYCODE_END|KEYCODE_HOME|KEYCODE_CTRL'))
        	return;
    }
	input_forceChanged(component);
}

function setCurrentfocusFromId(event, componentid)
{
    component = getElement(componentid);
    if(component)
    {
        hiddenForm = getHiddenForm();
        inputs = hiddenForm.elements;
        inputs.namedItem("currentfocus").value = component.id;
    }
}

function getFocusId()
{
	hiddenForm = getHiddenForm();
	if(hiddenForm)
	{
		inputs = hiddenForm.elements;
		if(inputs)
		{
			cf = inputs.namedItem("currentfocus");
			return cf.value;
		}
	}
	return "";
}

function setFocusId(event,component)
{
	var setfocus = component.getAttribute("sf")!="0";
    if (setfocus)
    {
    	hiddenForm = getHiddenForm();
   		inputs = hiddenForm.elements;
   		inputs.namedItem("currentfocus").value = component.id;
   	}
}

function setValueForFocusChange(event, component)
{
    hiddenForm = getHiddenForm();
    inputs = hiddenForm.elements;
    ccId = inputs.namedItem("changedcomponentid").value;
    ccVal = inputs.namedItem("changedcomponentvalue").value;
    clicked = component.getAttribute("clicked");
	if(ccId != "" && (component == null || component.id != ccId) && clicked!="true") // Something was changed
		sendEvent("setvalue", ccId, ccVal);
}

function setCurrentfocusId(event, component)
{
	setFocusId(event,component);
	setValueForFocusChange(event, component)
}

function input_mousedown(event, component)
{
    component.setAttribute("clicked", "true");
}

function input_onfocus(event, component)
{
    /* Test disabled */
    if(component.disabled)
        return false;

    // stopuseredit is only true if component has getProperty('usereditable').equals("false")
    var stopUserEdit = component.getAttribute("sue");
    if(component.readOnly == true && stopUserEdit!="1")
    {
    	if(component.className.indexOf("masked")==-1)
	    	appendClass(component, "ffro");
    }
    else
    {
    	appendClass(component, "ff");
        if(component.getAttribute("num") == "1" && component.getAttribute("sa") != "1")
        	component.style.textAlign = "left";
        setCurrentfocusId(event, component);
    }
}

function enableComponent(component)
{
    component.disabled = false;
    component.style.cursor = "pointer";
    component.tabIndex = "0";
    clr = component.getAttribute("originalcolor");
    if(undef(clr))
    	clr = "";
    component.style.color = clr;
}

function disableComponent(component)
{
    component.disabled = true;
    component.style.cursor = "default";
    component.tabIndex = "-1";
    component.setAttribute("originalcolor", component.style.color);
    component.style.color = "#C0C0C0";
}

function canClick(component)
{
	if(DESIGNMODE)
		return true;
    try
    {
        dis = component.getAttribute("disabled");
        if(undef(dis))
        	return true;
    }
    catch(error)
    {
        return true;
    }

    if(undef(dis))
    	return true;

    if(dis == "false" || dis == false)
    	return true;

    return false;
}


function showFieldHelpById(event, id)
{
    if(event.ctrlKey != true && (altPressed(event) == true))
    {
        helpEvent = "";
        if(hasKeyCode(event, "KEYCODE_F1"))
        	helpEvent = "fieldhelp";
        else if(hasKeyCode(event, "KEYCODE_I"))
        	helpEvent = "internalhelp";
        if(helpEvent != "")
        {
            sendEvent(helpEvent, id, "");
            cancelEvent(event);
        }
    }
}

function showFieldHelp(event, component)
{
	compId = component.id;
	showFieldHelpById(event, compId);
}

function numericcheck(event, component)
{
	num = component.getAttribute("num");
	if(num!="1")
		return;
	var re = /^[0-9-'.'-',']*$/;
	if (!re.test(component.value))
	{
		component.value = component.value.replace(/[^0-9-'.'-',':']/g,"");
		return false;
	}
}

function datespin(event, component)
{
    datefield = component.getAttribute("df");
    if(!undef(datefield))
	{
		id = component.id;

		if(isIE())
		{
			if(event.shiftKey && (event.keyCode == KEYCODE_UP_ARROW || event.keyCode == KEYCODE_AMP))//ie. when its 38 or 55
			{
				sendEvent("setcurrentdate", id, '');
				
			}
			
		}
		else
		{
			if(event.shiftKey && (event.charCode == KEYCODE_UP_ARROW || event.charCode == KEYCODE_AMP))
			{	
				cancelEvent(event);
				component.value = "";
				sendEvent("setcurrentdate", id, '');
				return;
			}			
		}
		
		if(hasKeyCode(event, "KEYCODE_UP_ARROW") || hasKeyCode(event, "NUMERIC_PAD_UP_ARROW"))
    	{
    		sendEvent("increment", id, '');
    	}

		if(hasKeyCode(event, "KEYCODE_DOWN_ARROW") || hasKeyCode(event, "NUMERIC_PAD_DOWN_ARROW"))
    	{
    		sendEvent("decrement", id, '');
    	}

    }
}

function input_lengthCheck(event,component,len)
{
	key = event.keyCode;
	if(component.value.length>=ml && document.selection.createRange().text=="")
	{
		if(event.ctrlKey!=true && (altPressed(event)!=true))
		{
			switch(key)
			{
				case KEYCODE_PAGEUP:
				case KEYCODE_PAGEDOWN:
				case KEYCODE_LEFT_ARROW:
				case KEYCODE_RIGHT_ARROW:
				case KEYCODE_UP_ARROW:
				case KEYCODE_DOWN_ARROW:
				case KEYCODE_DELETE:
				case KEYCODE_HOME:
				case KEYCODE_END:
				case KEYCODE_BACKSPACE:
				case KEYCODE_TAB:
				case KEYCODE_CTRL:
					break;
				case KEYCODE_ENTER:
					if(event.ctrlKey!=true)
					{
						event.returnValue=false
//						component.value=component.value.substring(0,ml);
						return false;
					}
					break;
				default:
					event.returnValue=false;
//					component.value=component.value.substring(0,ml);
					return false;
					break;
			}
		}
		else if(event.ctrlKey==true && key==KEYCODE_PASTE)
			return false;
	}
	return true;
}

function input_keydown(event, component)
{
    /* Test disabled */
    if(component.disabled)
    {
     	event.returnValue=false;
        return true;
    }

    if(hasKeyCode(event, "KEYCODE_ENTER") && event.ctrlKey)
    {
		try
		{
			lbId = component.getAttribute("li");
			if(!undef(lbId))
			{
				el=document.getElementById(lbId);
		        if(el)
		        {
		        	frontEndEvent(el, "click");
		        }
			}
		}
		catch(error)
		{
		}
    }
}

function input_onblur(event, component)
{
    /* Test disabled */
    if(component.disabled)
    {
        return false;
    }
    // stopuseredit is only true if component has getProperty('usereditable').equals("false")
    var stopUserEdit = component.getAttribute("sue");
    if(component.readOnly == true && stopUserEdit!="1")
    	removeClass(component, "ffro");
    else
    {
    	removeClass(component, "ff");
        if(component.getAttribute("num") == "1" && component.getAttribute("sa") != "1")
        	component.style.textAlign = "right";
    }
}

function changeImageSrc(id, src)
{
    cb = getElement(id);
    if(cb)
    	cb.src = src;
}

function clickElement(id)
{
    el = getElement(id);
    if(el)
    	el.click();
}

function toggleMinimize(objectId)
{
    if (objectId.indexOf("dialog_image2") > - 1)
    {
        // user clicked the MINIMIZE icon
        objectId = objectId.substring(0, objectId.indexOf("_image2"));
        objectId += "_dialog";
    }
    else if(objectId.indexOf("debug_event") > - 1 || objectId.indexOf("debug_stacktrace") > - 1)
    {
        // user clicked MINIMIZE on debug window
        el = document.getElementById(objectId + "_inner");
        if(el)
        {
            if(el.style.display == '')
            	el.style.display = 'none';
            else
            	el.style.display = '';
        }
        return;
    }
    else if(objectId.indexOf("dialog_dialog") > - 1)
    {
        // user double - clicked on the header bar
        // do nothing, just fall thru
    }
    else
    {
        // some other image was clicked so exit.
        return;
    }

    obj = getElement(objectId + "_inner");
    if(!obj)
    	return;
    obj.style.width = obj.clientWidth;

    // strip off _dialog and concatenate id with _image2
    var baseId = objectId.substring(0, objectId.indexOf("_dialog"));
    image = getElement(baseId + "_image2");
    if(!image)
    	return;

    var mainContent = getElement(objectId + "_content1");
    var shadowContent = getElement(objectId + "_bottomshadow");

    if(mainContent.style.display == "none")
    {
        if(image.src.indexOf("maximize.gif") > - 1)
        	image.src = IMAGE_PATH + "minimize.gif";
        else
        	image.src = IMAGE_PATH + "minimizesection.gif";
        mainContent.style.display = "";
        shadowContent.style.display = "";
    }
    else
    {
        if(image.src.indexOf("minimize.gif") > - 1)
        	image.src = IMAGE_PATH + "maximize.gif";
        else
        	image.src = IMAGE_PATH + "maximizesection.gif";
        mainContent.style.display = "none";
        shadowContent.style.display = "none";
    }
}

/* used to set the width of blanklines used for headerbar spacers to maintain widths on collapse */
function fixSpacers()
{
    spacers = document.getElementsByTagName("DIV")
    for(i = 0; i < spacers.length; i ++ )
    {
        spacer = spacers[i];
        if(spacer && spacer.className.indexOf("spacer") >= 0)
        {
            spacer.style.width = spacer.clientWidth;
        }
    }
}

	/* Used to suppress link visibility in status window */
	function noStatus()
	{
		try
		{
			window.status='Done';
			return true;
		}
		catch(error)
		{
		}
	}

function listbox_selectitem(event, component)
{
    component.className = "lis";
    /*
    deselect all other items
    is that going to be server side
    */
}

function lockWait()
{
    waitLocked = true;
}

function unLockWait()
{
    waitLocked = false;
}

//Takes focus off of page during wait periods
function focusWait()
{
	document.body.focus();
}

function showWait(element)
{
    if(DESIGNMODE)
    {
        parent.lockWait();
        if(!parent.waitOn)
        	parent.showWait();
        return;
    }

    stacktrace();
    if(element)
    {
        if(!isModal(element))
        	return;
        // no wait needed
    }
    if(element) // determine which wait to use, new one, or standard stop all
    	waitLayer = getElement(element.id + "_dialogwait");
    else
    	waitLayer = getElement("wait");

    if(waitLayer)
    {
        waitOn = true;
        document.body.cursor = "wait";
        waitLayer.style.position = "absolute";
        waitLayer.style.left = "0px";
        waitLayer.style.top = "0px";
        if(element) // belongs below an object
        	waitLayer.style.zIndex = element.style.zIndex - 1;
        else // belongs above everything
        	waitLayer.style.zIndex =  modalTopZ + 1;
        waitLayer.style.display = "inline";
        waitLayer.style.height = document.body.clientHeight;
        waitLayer.style.width = document.body.clientWidth;
    }
}

hideWaitInterval = null;
function hideWait()
{
    if(waitLocked)
    	return;

    if(TIMED_WAIT)
    	hideWaitInterval = window.setInterval(hideWaitTimed, 10);
    else
    	window.setTimeout(waitOff, 150);
    if(DESIGNMODE)
    {
    	parent.unLockWait();
    	parent.hideWait();
    }
}

function waitOff()
{
    waitLayer = getElement("wait");
    if(waitLayer)
    {
        waitLayer.style.zIndex = - 1;
        waitLayer.style.display = "none";
        document.body.cursor = "default";
        waitOn = false;
    }
}

function hideWaitTimed()
{
    waitLayer = getElement("wait");
    if(waitLayer)
    {
        wHeight = waitLayer.clientHeight;
        waitLayer.style.height = (wHeight - 700) + "px";
        if(wHeight <= 1000)
        {
            waitLayer.style.height = "0";
            window.clearInterval(hideWaitInterval);
            hideWaitInterval = null;
            waitOff();
        }
    }
}

function bringElementToTop(element)
{
    if(element)
    {
        if(!isModal(element))
        	element.style.zIndex = (modelessTopZ += 1);
    }
}

/* BEGIN menus */
function closeMenus()
{
    for(i = 0; i < openMenus.length; i ++ )
    {
        om = getElement(openMenus[i]);
        if(om)
        {
            om.parentNode.removeChild(om);
        }
    }
    openMenus = new Array();
}

function menuItemOver(event, mi)
{
    if(!mi)
    	return;

	mpId=mi.getAttribute("menuparent");
	mp=null;
	if(mpId)
		mp=document.getElementById(mpId);
    if(mi.tagName=="A")
    {
    	while(!undef(mi) && mi.tagName!="TABLE")
    	{
    		mi=mi.parentNode;
    	}
    }
   	if(undef(mi) || mi.tagName!="TABLE")
		return;
    itemCells = mi.rows[0].cells;
    for(i = 0; i < itemCells.length; i ++ )
    {
        appendClass(itemCells[i], "mih");
    }
    //we use id here because we don't have the num
	if(mp)
	{
	    oldCurrentId=mp.getAttribute("currentMenuItemId");
	    oldCurrent=null;
	    if(oldCurrentId && oldCurrentId!=mi.id)
	    	oldCurrent=document.getElementById(oldCurrentId);
	    if(oldCurrent)
		    menuItemOut(null,oldCurrent);
    	mp.setAttribute("currentMenuItemId",mi.id);
    }
}

function menuItemOut(event, mi)
{
//    mi = getElement(id);
    if(!mi)
    	return;
    if(mi.tagName=="A")
    {
    	while(!undef(mi) && mi.tagName!="TABLE")
    	{
    		mi=mi.parentNode;
    	}
    }
   	if(undef(mi) || mi.tagName!="TABLE")
		return;
    itemCells = mi.rows[0].cells;
    for(i = 0; i < itemCells.length; i ++ )
    {
        removeClass(itemCells[i], "mih");
    }
}
/* END menus */

/* BEGIN moveable */
function moveable_onmousedown(event, ctrlInst)
{
    srcEl = getSourceElement(event);
    bringElementToTop(ctrlInst);
    if(srcEl.className.indexOf("dh") > - 1 || ctrlInst.id=="dockedHiddenFrame")
    {
        if(event.layerY) //non-IE
        {
            ctrlInst.offsetY = event.layerY;
            ctrlInst.offsetX = event.layerX;
        }
        else
        {
            ctrlInst.offsetY = event.offsetY + (getTopPosition(srcEl) -  getTopPosition(ctrlInst));;
            ctrlInst.offsetX = event.offsetX + (getLeftPosition(srcEl) -  getLeftPosition(ctrlInst));
        }

        movingItem = ctrlInst;

        if(isModal(movingItem))
        	appendClass(movingItem, itemMoveClass);

        if(MAINDOC.capturEvents)
        {
            MAINDOC.captureEvents(Event.MOUSEMOVE);
            MAINDOC.captureEvents(Event.MOUSEUP);
            MAINDOC.onmousemove = moveItem;
            MAINDOC.onmouseup = releaseMoveItem;
        }
        else
        {
			addListener(window.document, "mousemove", moveItem, true );
            addListener(window.document, "mouseup", releaseMoveItem, true );
        }
	    moveRestrict = ctrlInst.getAttribute("direction");
	    if(undef(moveRestrict))
	    {
	    	customCurs = ctrlInst.getAttribute("movecursor");
	    	if((!undef(customCurs) && ctrlInst.style.cursor!=customCurs )|| ctrlInst.style.cursor!="move")
	    	{
		    	ctrlInst.setAttribute("oldcursor",ctrlInst.style.cursor);
				if(!undef(customCurs))
					ctrlInst.style.cursor=customCurs;
				else
			    	ctrlInst.style.cursor="move";
		    }
	    }

        if(ctrlInst.scrollList)
        {
            lst = ctrlInst.scrollList.split(",");
            for(scrollItem = 0; scrollItem < scrollList.length;scrollItem ++ )
            {
                scrll = getElement(scrollList[scrollItem]);
                if(scrll)
                	scrll.style.overflowX = "none";
            }
        }
		cancelEvent(event);
    }
}

function moveItem(event)
{
    cancelEvent(event);
    if(undef(movingItem))
    	return;
    ctrlInst = movingItem;
    if(!undef(ctrlInst))
    {
    	if(undef(moveRestrict) || moveRestrict=="vertical")
    	{
	        y = event.clientY - ctrlInst.offsetY;
	        if (y < -20)
	        	y = -20;
	        ctrlInst.style.top = y;
	    }
    	if(undef(moveRestrict) || moveRestrict=="horizontal")
    	{
	        ctrlInst.style.left = event.clientX - ctrlInst.offsetX;
	    }
    }
	moveMethod = movingItem.getAttribute("movemethod");
	if(!undef(moveMethod))
	{
		meth=moveMethod+"('"+ctrlInst.id+"')";
		eval(meth);
	}
	movingItem.setAttribute("hasmoved","true");
}

function releaseMoveItem(event)
{
    cancelEvent(event);
    ctrlInst = movingItem;
    if(ctrlInst)
    {
        if(MAINDOC.capturEvents)
        {
            MAINDOC.releaseEvents(Event.MOUSEMOVE);
            MAINDOC.releaseEvents(Event.MOUSEUP);
            MAINDOC.onmousemove = "";
            MAINDOC.onmouseup = "";
        }
        else
        {
            removeListener(window.document, "mousemove", moveItem, true );
            removeListener(window.document, "mouseup", releaseMoveItem, true );
        }
        if(ctrlInst.scrollList)
        {
            lst = ctrlInst.scrollList.split(",");
            for(scrollItem = 0; scrollItem < scrollList.length;
            scrollItem ++ )
            {
                scrll = getElement(scrollList[scrollItem]);
                if(scrll)
                	scrll.style.overflowX = "auto";
            }
        }

        if(isModal(movingItem))
        	removeClass(movingItem, itemMoveClass);
        x = movingItem.style.left;
        y = movingItem.style.top;
        movingItem.setAttribute("x", x);
        movingItem.setAttribute("y", y);
        dialogId = movingItem.id.substring(0, movingItem.id.indexOf("_inner"));
    	movingItem.style.cursor=movingItem.getAttribute("oldcursor");
		moveRestrict=null;
		releaseMethod = movingItem.getAttribute("releasemethod");
		if(!undef(releaseMethod))
		{
			meth=releaseMethod+"('"+movingItem.id+"')";
			eval(meth);
		}
        if(movingItem.id=="dockedHiddenFrame")
        	HFDocked="";
        else if(!isModal(movingItem) && movingItem.getAttribute("hasmoved")=="true")
        	sendEvent("setposition", dialogId, x + ":" + y);
        movingItem.setAttribute("hasmoved","false");
        movingItem = null;
    }
}


function moveable_onfocus(ctrlInst)
{
    if(ctrlInst.id.indexOf("_last") != - 1)
    {
        var prefix = ctrlInst.id.substring(0, ctrlInst.id.indexOf("_dialog_last"));
        document.getElementById(prefix + "_image2").focus();
    }
    else if(ctrlInst.id.indexOf("_first") != - 1)
    {
        var prefix = ctrlInst.id.substring(0, ctrlInst.id.indexOf("_first"));
        var last = document.getElementById(prefix + "_last");
        var button = document.getElementById(last.getAttributeNode("lastbuttonid").value);
        button.focus();
    }
}
/* END moveable */

function resizeTextArea(itId)
{
	it=document.getElementById(itId);
	if(undef(it))
		return;
	ownerid=it.getAttribute("ownerid");
	ownerEl=document.getElementById(ownerid);
	if(undef(ownerEl))
		return;

	w=getLeftPosition(it) + it.clientWidth - getLeftPosition(ownerEl)-1;
	h=getTopPosition(it) + it.clientHeight - getTopPosition(ownerEl)-1;
	if(w>it.clientWidth)
		ownerEl.style.width = w;
	else
		positionTextAreaResizer(ownerEl.id);
	if(h>it.clientHeight)
		ownerEl.style.height= h;
	else
		positionTextAreaResizer(ownerEl.id);
}

function setTextAreaSize(resId)
{
	res=document.getElementById(resId);
	if(undef(res))
		return;
	taId=res.getAttribute("ownerid");
	if(undef(taId))
		return;
	ta=document.getElementById(taId);
	if(undef(ta))
		return;
	w=ta.offsetWidth;
	h=ta.offsetHeight;
	sendEvent("resize", taId, "'"+w+":"+h+"'");
}

function positionTextAreaResizer(taId)
{
	ta=document.getElementById(taId);
	res=document.getElementById(taId+"_res");
	if(undef(res)||undef(ta))
		return;
	res.style.position="absolute";
	t=parseInt(ta.offsetHeight-res.offsetHeight + getTopPosition(ta) -1);
	res.style.top=t;
	l=parseInt(ta.offsetWidth-res.offsetWidth + getLeftPosition(ta) -1);
	res.style.left=l;
}

function isModal(ctrlInst)
{
    modal = ctrlInst.getAttribute("modal");
    if(modal == null || modal != "false")
    	return true;
    else
    	return false;
}

function setItemVisibility(id, visible)
{
    el = getElement(id);
    if(el)
    {
        el.style.visibility = visible;
    }
}

function setItemDisplay(id,disp)
{
    el = getElement(id);
    if(el)
    {
        el.style.display = disp;
    }
}

function refreshValue(id, value, title)
{
    el = getElement(id);
    if(el)
    {
        el.value = value;
        el.title = title+" "+value;
    }
}

function makeReadOnly(id, ro)
{
    el = getElement(id);
    if(el)
    {
        cName = el.className;
        if(ro)
        {
            appendClass(el, "readonly");
            el.readOnly = true;
            el.tabIndex = "-1";
        }
        else
        {
            removeClass(el, "readonly");
            el.readOnly = false;
            el.tabIndex = "0";
        }
    }
}

/*
* Returns the id of the last open menu
*/
function getLastOpenMenu()
{
    return openMenus[openMenus.length - 1];
}


/*
* Stores the x, y position of the last click
*/
function setClickPosition(el, event)
{
    lastClickElement = el;
}

function setExactClickPosition(event,el)
{
//	clickX=getLeftPosition(el);
//	clickY=getTopPosition(el);
	clickX=event.clientX-10;
	clickY=event.clientY+10;
}

/*
* Shows the given menu
*/
function showMenu(id, event, src)
{
    if(openMenus[0] == id)
    	return;
    var sub = getElement(id);
//    var src = getElement(source);

    if(src.tagName=="A")
    {
    	while(!undef(src) && src.tagName!="TABLE")
    	{
    		src=src.parentNode;
    	}
    }
   	if(undef(src) || src.tagName!="TABLE")
		return;
    var parentMenuId = src.getAttribute("menuparent");
    var parentMenu = document.getElementById(parentMenuId);
    var mainMenu = document.getElementById("menuholdertd");
//    setMenuHeight(sub);
    var currentAbsoluteLeft = getLeftPosition(src) + sub.offsetWidth;
    var currentRelativeLeft = getLeftPosition(src) - getLeftPosition(getElement(openMenus[0]));
    if (sub != null)
    {
        hideUnrelatedSubMenus(sub);
        var newLeft = currentRelativeLeft;
        offset = src.offsetWidth;
        sub.style.left = -5000;
        sub.style.top = -5000;
        if(parentMenu)
	       	offset = parseInt(parentMenu.offsetWidth);
        newLeft = currentRelativeLeft + offset;
        if((getLeftPosition(parentMenu)+ parentMenu.offsetWidth + sub.offsetWidth )> (document.body.offsetWidth - 10))
        {
        	tempLeft = newLeft;
            newLeft = currentRelativeLeft - sub.offsetWidth + 15;
            window.status=(newLeft*-1)+" > "+document.body.offsetWidth;
           	if(newLeft*-1 + sub.offsetWidth > document.body.offsetWidth)
           		newLeft+=(newLeft*-1 + sub.offsetWidth) - document.body.offsetWidth;
        }
        var newTop = getTopPosition(src) - parseInt(parentMenu.scrollTop) - getTopPosition(mainMenu);
        // need main menu for sub sub menus
        // var newTop = sub.offsetHeight - parentMenu.scrollTop; // getTopPosition(parentMenu);
        if((newTop + sub.offsetHeight) > document.body.clientHeight-20)
        {
            newTop -= (newTop + sub.offsetHeight) - (document.body.clientHeight-20);
        }
        if(newTop < 0)
        	newTop = 0;
        var parent = getElement(getLastOpenMenu());
        sub.style.left = newLeft-8;
        sub.style.top = newTop;
        sub.style.zIndex = parent.style.zIndex+100;
        sub.style.visibility = "visible";
        openMenus.push(id);
    }
}

/*
* Gets the absolute position of obj
*/

function getLeftPosition(obj)
{
    var curLeft = obj.offsetLeft;
    while(obj.offsetParent)
    {
        curLeft += obj.offsetParent.offsetLeft;
        try
        {
        	curLeft -= obj.offsetParent.scrollLeft;
        }
        catch(error)
        {
        	//do nothing, there is no left scrolling available
        }
        obj = obj.offsetParent;
    }
    return curLeft;
}

/*
* Gets the absolute position of obj
*/
function getTopPosition(obj)
{
    var curTop = obj.offsetTop;

    while(obj.offsetParent)
    {
        curTop += obj.offsetParent.offsetTop;
        try
        {
        	curTop -= obj.offsetParent.scrollTop;
        }
        catch(error)
        {
        	//do nothing, there is no top scrolling available
        }
        obj = obj.offsetParent;
    }
    return curTop;
}

function fixDialogPosition(id,ctrlId,max)
{
    var dialog = getElement(id+"_inner");
    if(!dialog)
    	return;
    if((dialog.offsetHeight>document.body.offsetHeight) || (dialog.offsetWidth>document.body.offsetWidth) || (getLeftPosition(dialog)+dialog.clientWidth)>document.body.offsetWidth)
    	setDialogPosition(id,ctrlId,max);
}

/*
* Positions the dialog in the middle of the screen
*/
function setDialogPosition(id,ctrlId,max)
{
    var dialog = getElement(id+"_inner");
    var scrollDiv  = getElement(ctrlId+"_bodydiv");
    var modal = false;
    var x = dialog.getAttribute("positionX");
    var y = dialog.getAttribute("positionY");
    if(scrollDiv)
    {
		if(dialog.offsetWidth>document.body.offsetWidth)
		{
			dialog.style.width=document.body.offsetWidth-50;
			scrollDiv.style.width=document.body.offsetWidth-70;
			scrollDiv.style.height=scrollDiv.offsetHeight+30;
			scrollDiv.style.overflow="auto";
		}

        if(max<0)
			max=document.body.clientHeight-150;

		if(max>0 && scrollDiv.offsetHeight>max)
		{
			scrollDiv.style.height=max+"px";
			scrollDiv.style.overflow="auto";
		}
	}
	dialog.style.top="-5000";
	dialog.style.left="-5000";
	dialog.style.visibility="visible";

    if(dialog.offsetHeight>document.body.offsetHeight)
    {
	    dialog.style.height=document.body.offsetHeight-100;
    }
	dialog.style.visibility="hidden";
    if(undef(x) || undef(y))
    {
        dialog.style.top = (document.body.offsetHeight /2) - (dialog.offsetHeight /2) + document.body.scrollTop; //(screen.height / 2 - dialog.offsetHeight / 2) - 100;
        dialog.style.left =  (document.body.offsetWidth /2 - dialog.offsetWidth /2) + document.body.scrollLeft;//screen.width / 2 - dialog.offsetWidth / 2;
    }
    else
    {
        dialog.style.left = x + document.body.scrollLeft;
        dialog.style.top = y + document.body.scrollTop;
    }
    if(isModal(dialog))
    {
	    modalTopZ += 10;
		modelessTopZ += 10;
        dialog.style.zIndex = modelessTopZ+1;
	}
	else
	{
		modelessTopZ += 10;
        dialog.style.zIndex = modelessTopZ;
	}
    dialog.style.width=dialog.offsetWidth;
	fadeDialog(id);
    showWait(dialog);
}

function fadeDialog(id)
{
    var dialog = getElement(id+"_inner");
	dialog.setAttribute("originalClass",dialog.className);
	if(FADE_VALUE<100)
		appendClass(dialog,"opacity_0");
	dialog.style.visibility="visible";
	if(FADE_VALUE<100)
		window.setTimeout("opacityUp('"+id+"',"+FADE_VALUE+")",FADE_SPEED);
}


function opacityUp(id, op)
{
   	var dialog = getElement(id+"_inner");
	replaceClass(dialog,"opacity_"+(op-FADE_VALUE), "opacity_"+op);
	if(op<100)
		window.setTimeout("opacityUp('"+id+"',"+(op+FADE_VALUE)+")",FADE_SPEED);
	else
		dialog.className=dialog.getAttribute("originalClass");
}

/*
* Positions the menuholder where the click was fired and set it as visible
*/
function setMenuPosition(id,type)
{
	clientArea=document.getElementById(clientAreaId);
	headerScrollDiv = document.getElementById(headerScrollDivId);

	bindEvents("table"); //menu - slow
    var holder = getElement("menuholder");
    var menu = document.getElementById(id);
	if(undef(menu))
		return;
    var openat = menu.getAttribute("openat");
    var top = 0;
    var left = 0;
    var	lastClickID=lastClickElement.id;
    if(!undef(lastClickID))
	    lastClickElement=document.getElementById(lastClickID);
	if(!undef(clickX) && !undef(clickY))
	{
        left = clickX;
        top = clickY;
        clickX=null;
        clickY=null;
	}
	else if (openat == "northwest")
    {
        // Context menus
        top = getTopPosition(lastClickElement);
        left = getLeftPosition(lastClickElement);
    }
    else if (openat == "parentsouthwest")
    {
     	lc=lastClickElement.getAttribute("lc");
     	var posEl;
     	if(!undef(lc))
     	{
     		posEl = document.getElementById(lc);
     	}
     	if(!undef(posEl))
     	{
			top= getTopPosition(posEl) + posEl.offsetHeight - 1;
			left = getLeftPosition(posEl) + 1;
     	}
     	else
     	{
	       	//Due to structural differences in combobox and toolbarcombobox
	       	//we must make sure we get the correct element to use for the left
		    testElement=lastClickElement.parentNode.parentNode.parentNode;
	        top = getTopPosition(testElement) + testElement.offsetHeight - 1;
	       	if(!undef(testElement.getAttribute("control")))
	       	{
				if(isIE())
		       		testElement=lastClickElement.parentNode.previousSibling;//.parentNode;
		       	else
		       		testElement=lastClickElement.parentNode.previousSibling.parentNode;
	       		if(testElement.firstNode)
	       			testElement=testElement.firstNode;
	       		else
	       			testElement=testElement.firstChild;
	        }
	        left = getLeftPosition(testElement) + 1;
        }
    }
    else
    {
        top = getTopPosition(lastClickElement) + lastClickElement.offsetHeight - 1;
        left = getLeftPosition(lastClickElement);
    }
    if(!isIE() && contains(clientArea, lastClickElement))
    {
    	top-=clientArea.scrollTop;
    	left-=clientArea.scrollLeft;
    }
	hrequired = parseInt(document.body.offsetWidth-2) - parseInt(menu.offsetWidth)-10;// + document.body.scrollLeft;
	vrequired = parseInt(document.body.offsetHeight-2) - parseInt(menu.offsetHeight);// + document.body.scrollTop;

    if(left > (hrequired))
    {
        left = document.body.offsetWidth - menu.offsetWidth - 5;
    }
    if(top > vrequired)
    {
        tempTop = top - menu.offsetHeight + 16;
        if(tempTop<5)
        {
			top=20;



        }
        else
        	top = tempTop;

		if(vrequired<5)
		{
			menuWidth = parseInt(menu.offsetWidth);
	       	menu.style.overflowY="scroll";
			top=20;
			menu.style.height=document.body.clientHeight-18;
			menu.style.width=menuWidth+13;
		}

    }

	if(type=="-1" && openat!="parentsouthwest")
		top=top-15;
    holder.style.top = top;
    holder.style.left = left;
    menu.style.visibility = "visible";
	addMouseDownEventsForPopups();
    setCurrentMenu(id);
    openMenus.push(id);
	focusMenuItem(id,0,true);
}

function menuKey(event,el,menuId)
{
	switch(event.keyCode)
	{
		case KEYCODE_UP_ARROW:
			focusMenuItem(menuId,-1,false);
			break;
		case KEYCODE_DOWN_ARROW:
			focusMenuItem(menuId,1,false);
			break;
		case KEYCODE_RIGHT_ARROW:
			menu_focusSub(event,el,menuId);
			break;
		case KEYCODE_LEFT_ARROW:
		case KEYCODE_ESC:
			menu_close(event,el,menuId);
			break;
		case KEYCODE_ENTER:
		case KEYCODE_SPACEBAR:
			if(!menu_focusSub(event,el,menuId))
			{
				src=getSourceElement(event);
				if(src.tagName!="A")
					src.click();
				else
					return;
			}
			break;
		case KEYCODE_TAB:
			if(event.shiftKey)
				focusMenuItem(menuId,-1,false);
			else
				focusMenuItem(menuId,1,false);
			break;
	}
	cancelEvent(event);
}

function menu_close(event,el,menuId)
{
	menu=currentMenu;
	if(!undef(menu))
	{
		menuParent = menu.getAttribute("menuparent");
		if(!undef(menuParent))
		{
			setCurrentMenu(menuParent);
			focusMenuItem(menuParent,0,false);
			hideMenu(menuId);
		}
		else
		{
			hideAllMenus(true);
		}
	}
}

function menu_focusSub(event,el,menuId)
{
	sub=el.getAttribute("submenu");
	if(!undef(sub))
	{
		submenu=document.getElementById(sub);
		if(submenu)
		{
			submenu.setAttribute("currentitem","");
			showMenu(sub,event,getSourceElement(event));
			setCurrentMenu(sub);
			focusMenuItem(sub,0,false);
			return true;
		}
	}
	return false;
}

function focusMenuItem(menuId,moveValue,newlyOpened)
{
	menu = currentMenu;
	if(!menu)
		return;
	menuItemArray = currentMenuItemList;
	if(undef(menuItemArray) || menuItemArray.length==0)
		return;
	itemCount = menuItemArray.length;
	currentfocusIndex=menu.getAttribute("currentitem");
	if(undef(currentfocusIndex) && moveValue==0)
	{
		//start trying at element 0
		currentfocusIndex=-1;
		moveValue=1;
	}
	else
	{
		if(moveValue==null)
		{
			currentfocusIndex=0;
			moveValue=0;
		}
		currentfocusIndex=parseInt(currentfocusIndex);
		//setup initial focus location
		if(moveValue>0)
		{
			if(currentfocusIndex==itemCount-1)
				currentfocusIndex=-1;
		}
		else
		{
			if(currentfocusIndex==0)
				currentfocusIndex=itemCount;
		}

	}
	look=true;
	//07-22214 - Adding a safety counter. We will only walk through 30 items
	walkCount = 0;
	while(look && currentMenu!=null && walkCount<30)
	{
		currentfocusIndex+=moveValue;
		id=menuItemArray[currentfocusIndex]+"_middle_anchor";
		anchor=document.getElementById(id);
		if(undef(anchor))
			return;
		if(anchor.getAttribute("disabled")!="disabled")
		{
			stopFocus=true;
			menu.setAttribute('currentitem',currentfocusIndex);
			delayTime = 300;
			if(SCREENREADER)
				delayTime=700;
			stopFocus=false;
			if(newlyOpened)
				delayedFocus(id,false,delayTime);
			else
				focusItemNow(id);
			look=false;
			continue;
		}
		if(moveValue>0)
		{
			if(currentfocusIndex==itemCount)
			{
				currentfocusIndex=-1;
			}
		}
		else
		{
			if(currentfocusIndex==0)
				currentfocusIndex=itemCount-1;
		}
		walkCount++;
	}
}

function setMenuHeight(menu)
{
    hasBeenSet = menu.getAttribute("heightset");
    if(!undef(hasBeenSet) && hasBeenSet == "true")
    	return;
    menuItemCount = parseInt(menu.getAttribute("itemcount"));
    originalHeight = parseInt(menu.clientHeight);
    itemHeight = originalHeight / menuItemCount;
    truewidth = parseInt(menu.offsetWidth);
    menu.style.overflow = "auto";
    menu.style.position = "absolute";
    menu.setAttribute("heightset", "true");
    if(!IE)
    	menu.style.width = (truewidth) + "px";
}

/*
* Hides the given menu
*/
function hideMenu(id)
{
	if(undef(id))
		return;
    var sub = null;
    if (id == "current")
    {
        sub = currentMenu;
    }
    else
    {
        sub = getElement(id);
    }
    if (sub != null)
    {
        sub.style.visibility = "hidden";
    }
    stopFocus=false;
}

/*
* Hides all open menus
*/
function hideAllMenus(nf)
{
	if(showingPopup)
		return;
	hidePopup();
	currentMenu=null;
    for(i = 0; i < openMenus.length; i ++ )
    {
        om = getElement(openMenus[i]);
        if(om)
            om.style.display = "none";
    }
    openMenus = new Array();
    showObjs();
	if(nf)
		delayedFocus(getFocusId(),true,100);
}

/*
* Hides all open menus no focus
*/
function hideAllMenusNF()
{
	if(showingPopup)
		return;
	hidePopup();
	currentMenu=null;
    for(i = 0; i < openMenus.length; i ++ )
    {
        om = getElement(openMenus[i]);
        if(om)
            om.style.display = "none";
    }
    openMenus = new Array();
    showObjs();
}

/*
* Goes through the menus hierarchy and hides all until it reaches the current menu's parent
*/
function hideUnrelatedSubMenus(menu)
{
	if(undef(menu))
		return;
    var parent = menu.getAttribute("menuparent");
    while(getLastOpenMenu() != parent)
    {
       	hideMenu(openMenus.pop());
    }
}

/*
* Goes through the menus hierarchy and hides all until it reaches the current menu
*/
function hideUnrelatedMenus(menu)
{
	if(undef(menu))
		return;
    while(getLastOpenMenu() != menu)
    {
       	hideMenu(openMenus.pop());
    }
}
/*
* Sets the current menu
*/
function setCurrentMenu(id)
{
    currentMenu = getElement(id);
    menuItemList=currentMenu.getAttribute("itemlist");
   	currentMenuItemList=menuItemList.split(",");
}

// removes leading and trailing whitespaces
function trim(value)
{
    return LTrim(RTrim(value));
}

// Removes leading whitespaces
function LTrim(value)
{
    var re = /\s*((\S+\s*)*)/;
    return value.replace(re, "$1");
}

// Removes ending whitespaces
function RTrim(value)
{
    var re = /((\s*\S+)*)\s*/;
    return value.replace(re, "$1");
}

/*
* Checks the CSS class of an element for a particular class.
*/
function classContains(id, className)
{
    el = getElement(id);
    if(!el)
    	return;
    cName=el.className;
    if(undef(cName))
    	return;
    if(el.className.indexOf(className) > - 1)
    	return true;
    return false;
}

/*
* Appends a CSS class to the existing class value.
*/
function appendClass(ctrlInst, cssClass)
{
	oldClass = ctrlInst.className;
	if(!undef(oldClass))
	{
	    if(!undef(ctrlInst) && oldClass.indexOf(cssClass)==-1)
	    {
	        ctrlInst.className = trim(oldClass) + " " + trim(cssClass);
	    }
	}
	else
	{
		ctrlInst.className=cssClass;
	}
}

/*
* Prepends a CSS class to the existing class value.
*/
function prependClass(ctrlInst, cssClass)
{
	oldClass = ctrlInst.className;
	if(!undef(oldClass))
	{
	    if(!undef(ctrlInst) && oldClass.indexOf(cssClass)==-1)
	    {
	        ctrlInst.className = trim(cssClass) + " " + trim(oldClass);
	    }
	}
	else
	{
		ctrlInst.className=cssClass;
	}
}


/*
* Completely removes a CSS class from the control.
*/
function removeClass(ctrlInst, cssClass)
{
    oldClass = ctrlInst.className;
    if(!undef(ctrlInst) && !undef(oldClass) && oldClass.indexOf(cssClass) > - 1 )
    {
        oldClass = oldClass.replace(cssClass, "");
        oldClass = oldClass.replace(/'  '+/g, '');
        ctrlInst.className = trim(oldClass);
    }
}

/*
* Replaces a CSS class with another.
*/
function replaceClass(ctrlInst, cssClass, cssClassReplaceWith)
{
    if(undef(ctrlInst))
    	return;
    controlClass = ctrlInst.className;
    if(!undef(ctrlInst) &&!ctrlInst.disabled && controlClass.indexOf(cssClass) > - 1 )
    {
        controlClass = controlClass.replace(cssClass, cssClassReplaceWith);
        controlClass = controlClass.replace(/'  '+/g, '');
        ctrlInst.className =  trim(controlClass);
    }
}


/*
* Checks to see if a value is null, empty or undefined
*/
function undef(p)
{
    var bUndef = false;
    switch(typeof(p))
    {
        case "undefined" :
        	bUndef = true;
    	    break;
        case "null" :
	        bUndef = true;
        	break;
        case "object" :
        	if(p == null)
        		bUndef = true;
        		break;
        case "number" :
	        if(null == p)
	        	bUndef = true;
    	    break;
        case "string" :
        	if("" == p)
        		bUndef = true;
	        if("null" == p)
	        	bUndef = true;
	        if("undefined" == p)
	        	bUndef = true;
	        break;
    }
    return bUndef;
}

/*
This method is used inside the bulletinboardportlet component
It expands / contracts messages inside the bulletinboard.
Since there is no interaction with the backend and this functionality is purely front - end,
this method is needed here. Modified by Venky for BB on 11/9/07
*/
function bboard_displayMessage(componentId, bbindex, expandOnlyOne,bulletinboarduid)
{
    var msgboxdiv = getElement(componentId + '_bbmessagemain_' + bbindex);
    var msgdiv = getElement(componentId + '_bbmessage_' + bbindex);
    var msglink = getElement(componentId + '_bbmessagelink_' + bbindex);
    var msgdate = getElement(componentId + '_bbmessagedate_' + bbindex);
    var msgtable = getElement(componentId + '_table');
    var shortmsg = getElement(componentId + '_bbmsg_'+bulletinboarduid);
    var fullsub = getElement(componentId + '_bbfullsub_'+bulletinboarduid);
    var shortsub = getElement(componentId + '_bbshortsub_'+bulletinboarduid);

    if(msgboxdiv.style.display == 'none')
    {
        msglink.className = "text bbmlo";
        //msgdate.className = "text bbmdo";

        msgboxdiv.style.display = 'inline';
        if(!undef(shortmsg))
        	shortmsg.style.display='none';
        fullsub.style.display='inline';
        shortsub.style.display='none';

		//This message is clicked to expand so it is Viewed/read. call the bean method to add this
	    //message to table
        sendEvent('bbmsgviewed', componentId, bulletinboarduid);

        if(expandOnlyOne)
        {
            if(msgtable.selectedMsgIndex != - 1)
            {
                var oldOpened = msgtable.selectedMsgIndex;
                var oldmsglink = getElement(componentId + '_bbmessagelink_' + oldOpened);
                var oldmsgdate = getElement(componentId + '_bbmessagedate_' + oldOpened);
                var oldmsgboxdiv = getElement(componentId + '_bbmessagemain_' + oldOpened);
                var oldshortmsg = getElement(componentId + '_bbmsg_'+bulletinboarduid);
    			var oldfullsub = getElement(componentId + '_bbfullsub_'+bulletinboarduid);
    			var oldshortsub = getElement(componentId + '_bbshortsub_'+bulletinboarduid);

                if(oldmsgboxdiv)
                {
                    oldmsgboxdiv.style.display = 'none';
                    oldshortmsg.style.display='inline';
                	oldfullsub.style.display='none';
        			oldshortsub.style.display='inline';
                    if(oldmsg)
                    {
                        oldmsglink.className = "text bbmlc";
                        oldmsgdate.className = "text bbmdc";
                    }
                }
            }
        }
        msgtable.selectedMsgIndex  = bbindex;
    }
    else
    {
        msglink.className = "text bbmlc";
        //msgdate.className = "text bbmdc";
        msgboxdiv.style.display = 'none';
        msgtable.selectedMsgIndex;
        if(!undef(shortmsg))
        	shortmsg.style.display='inline';
        fullsub.style.display='none';
        shortsub.style.display='inline';
    }
}

// Used for logging / testing
function log(stringVal, stamp)
{
    var logging = true;
    // Remove later
    logfile = "c:\\logjs.txt";
    if(logging == false)
    	return;
    timestamp = stamp;
    var fso = new ActiveXObject("Scripting.FileSystemObject");
    var a = fso.OpenTextFile(logfile, 8, true);
    if(timestamp != null && timestamp == true)
    	a.WriteLine(new Date + " : " + stringVal);
    else
        a.WriteLine(stringVal);
    a.Close();
}


function radiobutton_onkeypress(event, button, groupid)
{
	if(hasKeyCode(event, 'KEYCODE_RIGHT_ARROW|KEYCODE_DOWN_ARROW'))
	{
		el=document.getElementById(button.getAttribute("nextrb"));
		if(el)
			el.focus()
		return;
	}
	else if(hasKeyCode(event, 'KEYCODE_LEFT_ARROW|KEYCODE_UP_ARROW'))
	{
		el=document.getElementById(button.getAttribute("prevrb"));
		if(el)
			el.focus()
		return;
	}
	showFieldHelpById(event,groupid);
}

/*
This method is used inside the resultsetportlet component for filter inputs.
It changes the background color of the input fields.
Since these inputs are not standard textfields, we need this custom behaviour.
*/
function rsportlet_filterActivate(component, isActive)
{
    if(isActive)
    	appendClass(component, "ff");
    else
    	removeClass(component, "ff");
}

/*
This method fires the setValue of the resultset filter field. It works like input_changed
except that setvalue should go to the portelt control
*/
function rsportlet_onkeyup(component,componentId,controlId)
{
    var attribname = componentId.substr(0, componentId.indexOf("@"));
    var value = component.value;
    var qbe = attribname + "~^" + value;

    hiddenForm = getHiddenForm();
    inputs = hiddenForm.elements;
    inputs.namedItem("changedcomponentid").value = controlId;
    inputs.namedItem("changedcomponentvalue").value = qbe;
	inputs.namedItem("vischangedcomponentvalue").value = qbe;
}
/*
This method is used inside the resultsetportlet component for setting QBE through filter inputs.
Since these inputs are not standard textfields, we need this custom behaviour.
*/
function rsportlet_onkeypress(event, portletId, componentId)
{
    if(hasKeyCode(event, "KEYCODE_ENTER"))
    {
	    var element  = getElement(componentId);
	    var attribname = componentId.substr(0, componentId.indexOf("@"));
	    var value = element.value;
	    var qbe = attribname + "~^" + value;

    	sendEvent('setqbeandfilter', portletId, qbe);
    }
}

/*
A wrapper around setInterval used to set periodic calls to a method
It is necessary to use MAINDOC, there are problems if this is attempted
through the hidden frame
*/
function addTimeout(methodName, time)
{
	window.setTimeout(methodName, time);
}

function addQueryTimeout(methodName, time)
{
	currentQueryId = window.setInterval(methodName, time);
}

function cancelQueryTimeout()
{
	if(!undef(currentQueryId))
    {
        clearInterval(currentQueryId);
        currentQueryId = null;
    }
}

function callPeriodically(methodName, period)
{
    // setTimeout(methodName, 0);
    currentTimerId = setInterval(methodName, period);
}

function cancelTimerCalls()
{
    if(!undef(currentTimerId))
    {
        clearInterval(currentTimerId);
        currentTimerId = null;
    }
}

/*
Calls longopcheck on the long op dialog.
Unfortunately, the dialog name has to been hardcoded
*/
function dolongopcheck()
{
    sendEvent("longopcheck", "longopwait", null);
}

function dolongopquerycheck()
{
    sendEvent("longopquerycheck", "query_longopwait", null);
}


function showMessage(type, text, dialog)
{
	messageImageElement=null;
	if(dialog)
		messageElement = getElement("dialogmessage");
	else
	{
	    messageElement = getElement("titlebar_error");
	    messageImageElement = getElement("titlebar_error_image");
	}
    if(!messageElement)
    	return;
    if(messageImageElement)
    {
	    messageImage = IMAGE_PATH;
	    switch(type)
	    {
	        case 0 :
		        messageImage = "";
	    	    break;
	        case 1 :
		        // information
		        messageImage += "information.gif"
		        break;
	        case 2 :
		        // warning
		        messageImage += "exclamation.gif"
		        break;
	        case 3 :
		        // error
		        messageImage += "error.gif"
		        break;
	        default :
	        return;
	    }

	    if(messageImage != "")
	    {
	        messageImageElement.src = messageImage;
	        messageImageElement.style.visibility = "visible";
	    }
	}
    messageElement.innerHTML = "&nbsp;" + text;
    messageElement.style.visibility = "visible";
    if(messageTimeout!=null)
    {
	    window.clearTimeout(messageTimeout);
	    messageTimeout==null;
	}
    messageTimeout=window.setTimeout("removeUserMessage("+dialog+")", 5000);
}

function removeUserMessage(dialog)
{
	if(dialog)
		messageElement = getElement("dialogmessage");
	else
	    messageElement = getElement("titlebar_error");
	if(messageElement)
	    messageElement.style.visibility = "hidden";
	if(!dialog)
	{
	    messageImageElement = getElement("titlebar_error_image");
		if(messageImageElement)
		    messageImageElement.style.visibility = "hidden";
	}
	messageTimeout=null;
}

function sendClick(id)
{
    el = document.getElementById(id);
    if(el)
    	sendEvent('click', id, '');
}


function focusItem(id,sel)
{
	if(SCREENREADER)
		delayedFocus(id,sel,600);
	else
		delayedFocus(id,sel,50);
}

// Called to focus on an item, whether default focus for a container or a
// specifically focused component
function focusOnItem(id,sel)
{
    try
    {
        el = document.getElementById(id);
        if(el)
        {
        	if(el.tagName=="TEXTAREA")
        		sel=false;
            hiddenForm = getHiddenForm();
            if(hiddenForm)
            {
                inputs = hiddenForm.elements;
                if(inputs)
                {
                    cf = inputs.namedItem("currentfocus")
                    cName = el.className;
                    if(cf && el.getAttribute("ctype")!="menuitem")
                    	cf.value = id;
                }
            }
            if(!stopFocus)
            {
			    if(sel && !id.className)
			    {
                    if(el.className.indexOf('noselect')==-1)
                    {
                        el.select();
                    }
			    }
	            el.focus();
				hideFocus(el);
			}
        }
    }
    catch(error)
    {
		document.getElementById("tempselect").select();
		if(!stopFocus)
        {
        	try
        	{
				el.focus();
				hideFocus(el);
			}
			catch(error1)
			{
			}
		}
    }
}

function componentIsReadonly(id)
{
    return classContains(id, 'readonly');
}


function loadkpigraph(id, servpath)
{
    el = getElement(id);
    if(!undef(el))
    	el.src = servpath;
}

function doclinkuploadbutton(event, ctrlInst)
{
    //setValueForFocusChange(event, ctrlInst);
	upload_iframeDoc = getElement("upload_iframe").contentWindow.document;
    uploadForm = upload_iframeDoc.getElementById("IMPORT");
    uploadForm.submit();
}

function submituploadform(ctrlInst)
{
    alert('submituploadform');
    upload_iframeDoc = getElement("upload_iframe").contentWindow.document;
    uploadForm = upload_iframeDoc.getElementById("UPLOADIMPORT");
    uploadForm.submit();
}

function setPopupPosition(id)
{
    var popup = getElement(id);

    var top = 0;
    var left = 0;
	clientArea=document.getElementById(clientAreaId);
	header = document.getElementById(headerId);
    top = getTopPosition(lastClickElement);
    left = getLeftPosition(lastClickElement);
    if(!isIE() && contains(clientArea, lastClickElement))
    {
    	top-=clientArea.scrollTop;
    	left-=clientArea.scrollLeft;
    }
	hrequired = parseInt(document.body.offsetWidth-2) - parseInt(popup.offsetWidth)-10 + document.body.scrollLeft;
	vrequired = parseInt(document.body.offsetHeight-2) - parseInt(popup.offsetHeight) + document.body.scrollTop;

    /* Fix menu opening off limits */
    if (left > hrequired)
    {
        left = document.body.offsetWidth - popup.offsetWidth - 10;
    }
    if (top > vrequired)
    {
        top = document.body.offsetHeight - popup.offsetHeight - 3;
    }

    popup.style.top = top;
    popup.style.left = left;

    modalTopZ += 10;
    popup.style.zIndex = modalTopZ;
    addMouseDownEventsForPopups();
}

function addMouseDownEventsForPopups()
{
 	if(!DESIGNMODE)
 	{
	    addListener(clientArea, "mousedown", hideAllMenusNF, false);
		addListener(headerScrollDiv, "mousedown", hideAllMenusNF, false);
	}
}

function hidePopup()
{
    var popupNode = getElement("popup");
	//all we have to do is hide the popup since any event sent to a non-popup page while a popup is open will kill it
    if(!undef(popupNode) && !undef(popupNode.parentNode))
       	popupNode.parentNode.style.display="none";
    popupCount=0;
}

function enablePopupEvents()
{
    popupNode = getElement("popup");

    if(IE)
        removeListener(popupNode, "click", cancelEvent, true);
    else
        removeListener(popupNode, "click", cancelEvent, true);
}

function disablePopupEvents()
{
    popupNode = getElement("popup");

    if(IE)
        addListener(popupNode, "click", cancelEvent, true);
    else
        addListener(popupNode, "click", cancelEvent, false);
}

function anyAltPressed(event)
{
	return event.altKey;
}

function tableHotkey(event, element)
{
    var hk = tableHotkeys[event.keyCode];
    if ( hk != undefined  &&  hk[0] == event.ctrlKey  &&  (hk[1] == altPressed(event)))
    {
    	// if a hotkey requires that alt not be pressed, we should check left and right
		if(hk[1]==false && anyAltPressed(event))
			return;
        var target = element.id;
        var eventname = hk[2];
        sendEvent(eventname, target, "");
        cancelEvent(event);
    }
}

// appHotkeys gets populated at the bottom of page.jsp
var appHotkeys = new Array();

function appHotkey(event)
{
    var params;
    var hotkeysForKeycode = appHotkeys[event.keyCode];
    if (hotkeysForKeycode == undefined)
	    return false;
	if(dialogCount>0)
		return; //application hotkeys are not allowed on dialogs

    for (i = 0; i < hotkeysForKeycode.length; i ++ )
    {
        params = hotkeysForKeycode[i];
        if ( event.ctrlKey == params[0] && (altPressed(event) == params[1]))
        {
   	    	// if a hotkey requires that alt not be pressed, we should check left and right
			if(!params[1] && anyAltPressed(event))
				return;
            var target = params[2];
            var eventname = params[3];
            lastClickElement = getElement(target);
            sendEvent(eventname, target, "");
            cancelEvent(event);
            return true;
        }
    }

    return false;
}

function hideObjs()
{
    if(objsHidden)
    	return;

    objs = document.getElementsByTagName("OBJECT");
    len = objs.length;
    for(i = 0; i < len; i ++ )
    {
        obj = objs[i];
        ch = obj.clientHeight;
        cw = obj.clientWidth;
        if(ch > 0)
        {
            if (obj.height.indexOf("%") > - 1)
            	obj.setAttribute("dimensionHeight",obj.height);
            else
            	obj.setAttribute("dimensionHeight",ch);

            if (obj.width.indexOf("%") > - 1)
            	obj.setAttribute("dimensionWidth",obj.width);
            else
            	obj.setAttribute("dimensionWidth",cw);

            obj.style.height = "1px";
            obj.style.width = "1px";
            back = document.getElementById(obj.id + "_back");
            if(back)
            	back.style.display = "";
            objsHidden = true;
        }
    }
}

function showObjs()
{
    if ((objsHidden == false) || (dialogCount > 0))
	    return;

    objsHidden = false;
    objs = document.getElementsByTagName("OBJECT");
    len = objs.length;
    for(walkobjs = 0; walkobjs < len; walkobjs ++ )
    {
        obj = objs[walkobjs];
        back = document.getElementById(obj.id + "_back");
        if(back)
        	back.style.display = "none";

        obj.style.height = obj.getAttribute("dimensionHeight");
        obj.height = obj.getAttribute("dimensionHeight");
        obj.style.width = obj.getAttribute("dimensionWidth");
        obj.width = obj.getAttribute("dimensionWidth");
    }
}

function addPasswordField(id)
{
	passwordFields[passwordFields.length]=id;
}

function replaceAllItems()
{
	//first set is non-default
	len = rerenderedItems.length;
	for(i=0;i<len;i++)
	{
		replaceItem(rerenderedItems[i]);
	}
	rerenderedItems=new Array();

	//this set is defaultrender=true
	rerenders = HIDDENDOC.getElementsByTagName("DIV");
	len = rerenders.length;
	for(i=0;i<len;i++)
	{
		it = rerenders[i];
		needsRef = it.getAttribute("needsrefresh");
		if(needsRef=="true")
			replaceItem(it);
	}
	rerenders=null;

}

function fixPasswordFields()
{
	len = passwordFields.length;
	for(i=0;i<len;i++)
	{
		 pwdField = getElement(passwordFields[i]);
		 if(pwdField)
		 {
		 	hasValue = pwdField.getAttribute("hasvalue");
		 	if(hasValue=="1")
			 	pwdField.value="XXXXXXXXXX";
		 }
	}
	//passwordFields=new Array();
}

function renderItem(id,vis)
{
	this.id=id;
	this.vis=vis;
}

function addRerendered(itemid,vis)
{
	if(undef(vis) || (vis!=true && vis!=false))
		vis=true;
	rerenderedItems[rerenderedItems.length]=new renderItem(itemid,vis);;
}

function replaceItem(holderItem)
{
	try
	{
		newHolder = document.getElementById(holderItem.id);
		oldHolder = MAINDOC.getElement(holderItem.id);
		newVis = true;
		nv = newHolder.getAttribute("vis");
		if(!undef(nv) && nv=="false")
			newVis=false;
		vis = holderItem.vis;
		if(undef(vis))
			vis=true;
		if(newHolder && oldHolder)
		{
			if(!vis || !newVis || newHolder.style.display=="none")
			{
				oldHolder.style.display="none";
			}
			else
			{
				oldHolder.innerHTML = newHolder.innerHTML;
				oldHolder.style.display="inline";
			}
			// we need to remove these elements from the hiddenframe so JAWS does not pick them up in it's lists
			//This is now done in the hiddenframefooter
				//newHolder.innerHTML="";
				//newHolder.parentNode.removeChild(newHolder);
		}
	}
	catch(error)
	{
	}
}

//Used for logging/testing
function fileLog(stringVal, stamp)
{
	timestamp = stamp;
	if(undef(timestamp))
		timestamp=true;
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	var a = fso.OpenTextFile(logfile, 8, true);
	if(timestamp!=null && timestamp==true)
		a.WriteLine(new Date + " : " + stringVal);
	else
		a.WriteLine(stringVal);
	a.Close();
}

function scrollScreen(scrolltop, scrollleft)
{
	parent.document.scrollTop = scrolltop;
	parent.document.scrollLeft = scrollleft;
}

function scrollToMiddle( parentDiv,elementIntoDiv)
{
	parentDiv.scrollTop = getTopPos(elementIntoDiv) - getTopPos(parentDiv) - 16;
}

function getTopPos(el)
{
var cursortop = 0;
	if (el.offsetParent)
	{
		while (el.offsetParent)
		{
			cursortop += el.offsetTop
			el = el.offsetParent;
		}
	} else if (el.y)
	{
		cursortop += el.y;
	}
	return cursortop;
}

function updateValue(id,val)
{
	el = document.getElementById(id);
	if(el)
		el.value=val;
}


function updateDisplay(id,disp)
{
	el = document.getElementById(id);
	if(el)
		el.style.display=disp;
}

function updateClass(id,css)
{
	el = document.getElementById(id);
	if(el)
		el.className=css;
}

function fixRecordImageSize(id)
{
	dv = document.getElementById(id);
	if(dv)
	{
		if(dv.offsetHeight>(document.body.offsetHeight-250))
		{
			dv.style.height=document.body.offsetHeight-250;
			dv.style.width=dv.style.height;
		}
		if(dv.offsetWidth>document.body.offsetWidth)
			dv.style.width=document.body.offsetWidth-50;
	}
}

function focusItemNow(id)
{
	try
	{
		if(!stopFocus)
		{
			el = document.getElementById(id);
			if(!el)
				return false;
			el.focus();
			hideFocus(el);
		}
	}
	catch(error)
	{
		return false;
	}
	return true;
}

function delayedFocus(id,sel,menuDelay)
{
	if(undef(menuDelay))
		menuDelay=300;
	window.setTimeout("focusOnItem('"+id+"',"+sel+")",menuDelay);
}

function reFocusItem()
{
	hiddenForm = getHiddenForm();
	if(hiddenForm)
	{
    	inputs = hiddenForm.elements;
    	if(inputs)
    	{
	    	focId = inputs.namedItem("currentfocus").value;
	    	if(!undef(focId))
	    		focusItemNow(focId);
	    }
	}
}

function setCanvasURL(canvasId,url)
{
	var canvas = document.getElementById(canvasId);
	if (canvas!=null)
		canvas.src = url;
}


/************************  NEW **************************/

function tabClick(id)
{
	if(classContains(id+"_middle", "off"))
	{
		sendEvent("click",id,"");
	}
}

function tabSelect(id)
{
    if(classContains(id+"_middle", "off"))
    {
        sendEvent("select",id,"");
    }
}

function tr_key(event,component)
{
	if(event.keyCode==KEYCODE_ENTER)
	{
		sendEvent('filterrows',component.id,'');
		cancelEvent(event);
	}
}

function hideShowElement(id,disp)
{
	el=getElement(id);
	if(el)
		el.style.display=disp;
}

function sizeClientArea()
{
	clientArea = document.getElementById(clientAreaId);
	header = document.getElementById(headerId);
	headerScrollDiv = document.getElementById(headerScrollDivId);
	fix=2;

	//make room for breadcrumbs if there are any
    breadcrumbsHeight=0;
    if (typeof breadcrumbsId != 'undefined')
    {
        breadcrumbsHeight = 15;
    }

	if (clientArea && header)
	{
		bodyScroll = document.body.scrollHeight;
		if (bodyScroll > 0)
		{
			bodyHeight = document.body.clientHeight;
			headerHeight = header.clientHeight;
			headerScrollDiv.style.width = document.body.clientWidth;

			if (headerScrollDiv.scrollHeight > headerScrollDiv.clientHeight)
				hsDivHeight = headerScrollDiv.scrollHeight + 15; //an extra 15px to fit in a scroll bar when needed
			else
				hsDivHeight = headerScrollDiv.scrollHeight;

			headerScrollDiv.style.height = hsDivHeight;
			headerScrollDiv.scrollTop = 0;
			clientArea.style.height = bodyHeight - hsDivHeight - fix - breadcrumbsHeight;
			clientArea.style.width = document.body.clientWidth;
		}
	}
	window.onresize=sizeClientArea;
	hidePopup();
}

/*
BEGIN SPECIFIC COMPONENT HANLDERS
used to reduce bandwidth by reducing inline script attachment
*/
/* checkbox handler */
function cb_(event)
{
	event = (event) ? event : ((window.event) ? window.event : "")
	if(DESIGNMODE)
		return;
	imgId=this.getAttribute("imgid");
	imgEl=getElement(imgId);
	ro = imgEl.getAttribute("readonly")=="true";
	switch(event.type)
	{
		case "blur":
			input_onblur(event,this);
			break;
		case "click":
			if(!ro)
				sendEvent('toggle',this.id,'');
			break;
		case "focus":
			input_onfocus(event,this);
			break;
		case "keydown":
			if(!ro && hasKeyCode(event,'KEYCODE_SPACEBAR|KEYCODE_ENTER'))
			{
				sendEvent('toggle',this.id,'');
				cancelEvent(event);
			}
			showFieldHelp(event,this);
			break;
		case "mousedown":
			input_mousedown(event,this);
			break;
		case "mouseover":
			input_mousedown(event,this);
		case "mouseout":
			if(imgEl.getAttribute("readonly")!="true")
			{
				if(event.type=="mouseout")
					this.setAttribute("clicked","false");
				imageType=imgEl.getAttribute("imgtype");
				if(!undef(imageType))
				{
					imageName=imgEl.getAttribute("imgname");
					checked=imgEl.getAttribute("checked");
					over=".";
					if(event.type=="mouseover")
					 over="_over.";
					imgEl.src=IMAGE_PATH+imageName+checked+over+imageType;
				}
			}
			return noStatus();
			break;
	}
}

/* image handler */
function im_(event)
{
	event = (event) ? event : ((window.event) ? window.event : "")
	ro = this.readOnly;
	eventValue=this.getAttribute("ev");
	active=!(this.getAttribute("active")=="0");
	switch(event.type)
	{
		case "blur":
			input_onblur(event,this);
			break;
		case "click":
			if(active)
			{
				toggleMinimize(this.id);
				lc=this.getAttribute("lc");
				if(lc!="")
					setCurrentfocusFromId(event,lc);
				setClickPosition(this,event);
				sendEvent('click',this.id,eventValue);
			}
			break;
		case "focus":
			setCurrentfocusId(event,this);
			break;
		case "keydown":
			if(active && hasKeyCode(event,'KEYCODE_SPACEBAR|KEYCODE_ENTER'))
			{
				setClickPosition(this,event);
				sendEvent('click',this.id,eventValue);
				cancelEvent(event);
			}
			break;
		case "mousedown":
			input_mousedown(event,this);
			break;
		case "mouseover":
			imageType=this.getAttribute("imgtype");
			if(active && imageType!="")
			{
				src=this.getAttribute("source");
				this.src=IMAGE_PATH+src+"_over"+imageType;
			}
			break
		case "mouseout":
			imageType=this.getAttribute("imgtype");
			if(active && imageType!="")
			{
				src=this.getAttribute("source");
				this.src=IMAGE_PATH+src+imageType;
			}
			break;
	}
}

/* label handler */
function label_(event)
{
	event = (event) ? event : ((window.event) ? window.event : "");
	nc=this.getAttribute("noclick");
	switch(event.type)
	{
		case "focus":
			setCurrentfocusId(event,this);
			break;
		case "keypress":
			if(nc!="1" && hasKeyCode(event,'KEYCODE_ENTER'))
			{
				eventValue=this.getAttribute("ev");
				mxevent=this.getAttribute("mxevent");
				if(!undef(mxevent))
				{
					targetid=this.getAttribute("targetid");
					setClickPosition(this,event);
					sendEvent(mxevent,targetid,eventValue);
					cancelEvent(event);
				}
			}
			break;
		case "mousedown":
			input_mousedown(event,this);
			break;
		case "mouseout":
			ul=this.getAttribute("ul");
			if(nc!="1" && ul!="1")
				this.style.textDecoration="";
			break;
		case "mouseover":
			ul=this.getAttribute("ul");
			if(nc!="1" && ul!="1")
				this.style.textDecoration="underline";
			break;
		case "mouseup":
			//cannot click on labels in FF so we use mouseup
			if(nc!="1")
			{
				eventValue=this.getAttribute("ev");
				mxevent=this.getAttribute("mxevent");
				if(!undef(mxevent))
				{
					targetid=this.getAttribute("targetid");
					setClickPosition(this,event);
					sendEvent(mxevent,targetid,eventValue);
					cancelEvent(event);
				}
			}
			break
	}
}

/* menuitem handler */
function mi_(event)
{
	event = (event) ? event : ((window.event) ? window.event : "")
	menuParent=this.getAttribute("menuparent");
	subMenu=this.getAttribute("submenu");
	switch(event.type)
	{
		case "blur":
			if(this.tagName=="A")
			{
				menuItemOut(event,this);
				return noStatus();
			}
			break;
		case "click":
			if(this.tagName=="TABLE")
			{
				itemdisabled=this.getAttribute("itemdisabled")=="true";
				if(!undef(subMenu) || itemdisabled)
					cancelEvent(event);
				else
				{
					menusId=this.getAttribute("menusid");
					rsq=this.getAttribute("rsq");
					itemId=this.id;
					if(rsq=="1")
				        itemId = itemId.replace("\"", "'");
					lastClickElement=this;
					sendEvent("click",menusId,itemId);
					hideAllMenus();
					event.cancelBubble=true;
				}
			}
			break;
		case "focus":
			if(this.tagName=="A")
			{
				menuItemOver(event,this);
				hideFocus(el);
				return noStatus();
			}
			break;
		case "keydown":
			if(this.tagName=="A")
				menuKey(event, this, menuParent);
			break;
		case "mouseout":
			if(this.tagName=="TABLE")
				menuItemOut(event,this);
			break;
		case "mouseover":
			if(this.tagName=="TABLE")
			{
				if(!undef(subMenu))
					showMenu(subMenu,event,this);
				else
					hideUnrelatedMenus(menuParent);
				menuItemOver(event,this);
				return noStatus();
			}
			break;
	}
}
/* pushbutton handler */
function pb_(event)
{
	event = (event) ? event : ((window.event) ? window.event : "")
	if(this.disabled || DESIGNMODE)
		return;
	eventValue=this.getAttribute("ev");
	mxevent=this.getAttribute("mxevent");
	switch(event.type)
	{
		case "click":
			setClickPosition(this,event);
			if(this.getAttribute("dub")=="1")
				doclinkuploadbutton(event,this);
			else
				sendEvent('click',this.id,'');
			break;
		case "focus":
			setCurrentfocusId(event,this);
			break;
		case "mousedown":
			input_mousedown(event,this);
			break;
		case "mouseout":
			removeClass(this,'pbo');
			this.setAttribute("clicked","false");
			break;
		case "mouseover":
			appendClass(this,'pbo')
			break;
	}
}

/* radiobutton handler */
function rb_(event)
{
	event = (event) ? event : ((window.event) ? window.event : "")
	if(DESIGNMODE)
		return;
	switch(event.type)
	{
		case "click":
			if(!this.disabled)
			{
				setClickPosition(this,event);
				sendEvent('click',this.id,'');
			}
			break;
		case "focus":
			setFocusId(event,this);
			break;
		case "keydown":
			rbsId=this.getAttribute("rbsId");
			radiobutton_onkeypress(event,this,rbsId);
			break;
		case "keypress":
			if(hasKeyCode(event, 'KEYCODE_ENTER') && !this.disabled)
				sendEvent('click',this.id,'');
			break;
	}
}

/* textarea handler */
function ta_(event)
{
	event = (event) ? event : ((window.event) ? window.event : "")
	if(DESIGNMODE)
		return;
	ro = this.readOnly;
	if(ro)
		return;
	switch(event.type)
	{
		case "blur":
			input_onblur(event,this);
			break;
		case "change":
			input_changed(event,this);
			break;
		case "focus":
			input_onfocus(event,this);
			this.select();
			setCursor(this,this.value.length);
			break;
		case "keydown":
			if(!ro)
				input_keydown(event,this);
			else if(hasKeyCode(event,KEYCODE_BACKSPACE))
			{
			    event.cancelBubble=true;
			    event.returnValue=false;
			}
			break;
		case "keyup":
			input_changed(event,this);
			break;
		case "paste":
			input_changed(event, this)
			break;
		case "cut":
			input_changed(event, this)
			break;
	}
}

/* textbox handler */
function tb_(event)
{
	event = (event) ? event : ((window.event) ? window.event : "")
	if(DESIGNMODE)
		return;
	ro = this.readOnly;
	switch(event.type)
	{
		case "blur":
			input_onblur(event,this);
			break;
		case "change":
			if(!ro)
				input_changed(event,this);
			break;
		case "click":
			liclick=this.getAttribute("liclick");
			li=this.getAttribute("li");
			if(li!="" && liclick=="1")
				frontEndEvent(getElement(li),'click');
			break;
		case "focus":
			input_onfocus(event,this);
			this.select();
			break;
		case "keydown":
			if(!ro)
				input_keydown(event,this);
			else if(hasKeyCode(event,'KEYCODE_DOWN_ARROW|KEYCODE_ENTER'))
			{
				lbId = this.getAttribute("li");
				frontEndEvent(getElement(lbId),'click');
			}
			else if(hasKeyCode(event,KEYCODE_BACKSPACE))
			{
			    event.cancelBubble=true;
			    event.returnValue=false;
			}
			break;
		case "keypress":
			if(!ro)
			{
				if(event.ctrlKey==false && hasKeyCode(event,'KEYCODE_ENTER'))
				{
					db = this.getAttribute("db");
					if(db!="")
						sendClick(db);
				}
			}
		case "keyup":
			if(!ro)
			{
				numericcheck(event,this);
				input_changed(event,this);
				datespin(event,this);
			}
			else
			{
				setFocusId(event,this);
				showFieldHelp(event, this);
			}
			break;
	}
}

/* tablecell handler */
function tc_(event,component)
{
	if(DESIGNMODE)
		return;
	// bound directly from the jsp, 'this' is not valid
	tRrow=component.parentNode;
	row = parseInt(component.getAttribute("row"));
	switch(event.type)
	{
		case "click":
			currentRow = (component.getAttribute("currentrow")=="true");
			if(!currentRow && row>=0)
			{
				sendEvent('click',component.id,'');
				event.cancelBubble=true;
			}
			break;
		case "mouseout":
			if(row>=0)
				removeClass(tRrow,'tableRowHover')
			break;
		case "mouseover":
			if(row>=0)
				appendClass(tRrow,'tableRowHover');
			break;
	}
}

/* toggleimage handler */
function ti_(event)
{
	event = (event) ? event : ((window.event) ? window.event : "")
	if(DESIGNMODE)
		return;
	eventValue=this.getAttribute("ev");
	imgid=this.getAttribute("compid");
	active=!(this.getAttribute("active")==0);
	switch(event.type)
	{
		case "blur":
			input_onblur(event,this);
			break;
		case "click":
			if(active)
			{
				setFocusId(event,getElement(this.getAttribute("compid")));
				setClickPosition(this,event);
				sendEvent('click',imgid,eventValue);
			}
			break;
		case "focus":
			setCurrentfocusId(event,this);
			break;
		case "keydown":
			if(active && hasKeyCode(event,'KEYCODE_SPACEBAR|KEYCODE_ENTER'))
			{
				sendEvent('click',imgid,eventValue);
				cancelEvent(event);
			}
			break;
		case "mousedown":
			input_mousedown(event,this);
			break;
		case "mouseover":
			imgEl = getElement(imgid);
			imageType=imgEl.getAttribute("imgtype");
			if(active && imageType!="")
			{
				src=imgEl.getAttribute("source");
				imgEl.src=IMAGE_PATH+src+"_over"+imageType;
			}
			return noStatus();
			break
		case "mouseout":
			imgEl = getElement(imgid);
			imageType=imgEl.getAttribute("imgtype");
			if(active && imageType!="")
			{
				src=imgEl.getAttribute("source");
				imgEl.src=IMAGE_PATH+src+imageType;
			}
			break;
	}
}

/* 	Event binding code */
function bindEvents(tag)
{
//	if(DESIGNMODE)
//		return;
	list=document.getElementsByTagName(tag);
	for(i=0;i<list.length;i++)
	{
		el=list[i];
		type=el.getAttribute("ctype");
		if(type=="")
			continue;
		de=el.getAttribute("de");
		switch(type) //what type of component?
		{
			case "checkbox":
				el.onblur=cb_;
				el.onclick=cb_;
				el.onfocus=cb_;
				el.onkeydown=cb_;
				if(!DESIGNMODE)
					el.onmousedown=cb_;
				el.onmouseout=cb_;
				el.onmouseover=cb_;
				break;
			case "image":
				if(!DESIGNMODE || de=="1")
				{
					el.onblur=im_;
					el.onclick=im_;
					el.onfocus=im_;
					el.onkeydown=im_;
					el.onmousedown=im_;
					el.onmouseout=im_;
					el.onmouseover=im_;
				}
				break;
			case "label":
				if(!DESIGNMODE || de=="1")
				{
					el.onfocus=label_;
					el.onkeypress=label_;
					el.onmousedown=label_;
					el.onmouseout=label_;
					el.onmouseover=label_;
					el.onmouseup=label_;
				}
				break;

			case "menuitem":
				if(tag=="a")
				{
					el.onblur=mi_;
					el.onfocus=mi_;
					el.onkeydown=mi_;
				}
				else if(tag=="table")
				{
					el.onclick=mi_;
					el.onmouseout=mi_;
					el.onmouseover=mi_;
				}
				break;
			case "pushbutton":
				if(!DESIGNMODE) //we don't want to change the pushbutton div used in App Designer
				{
					el.onclick=pb_;
					el.onfocus=pb_;
					el.onmousedown=pb_;
					el.onmouseout=pb_;
					el.onmouseover=pb_;
				}
				break;
			case "radiobutton":
				iType=el.getAttribute("type");
				if(iType="radio")
				{
					el.onclick=rb_;
					el.onfocus=rb_;
					el.onkeydown=rb_;
					el.onkeypress=rb_;
				}
				break;
			case "textarea":
				el.onblur=ta_;
				el.onchange=ta_;
				el.onfocus=ta_;
				el.onkeydown=ta_;
				el.onkeypress=ta_;
				el.onkeyup=ta_;
				el.oncut=ta_;
				el.onpaste=ta_;
				break;
			case "textbox":
				el.onblur=tb_;
				el.onclick=tb_;
				el.onchange=tb_;
				el.onfocus=tb_;
				el.onkeydown=tb_;
				el.onkeypress=tb_;
				el.onkeyup=tb_;
				break;
			case "toggleimage":
				el.onblur=ti_;
				el.onclick=ti_;
				el.onfocus=ti_;
				el.onkeydown=ti_;
				el.onmousedown=ti_;
				el.onmouseout=ti_;
				el.onmouseover=ti_;
				break;
		}
	}
}

//This method is used to deselect text in a textarea and position cursor
//at the end of the text
function setCursor(inputEl, curPos)
{
	if (inputEl.setSelectionRange)
	{
		inputEl.focus();
		inputEl.setSelectionRange(curPos, curPos);
	}
	else if (inputEl.createTextRange)
	{
		var range = inputEl.createTextRange();
		range.collapse(true);
		range.moveStart('character', curPos);
		range.select();
	}
}

// Added for issue 08-19268
function callWebReplayFrame() {
	try {
		for ( var i=0; i<window.top.frames.length; i++ )
		{
			var wr_frame = window.top.frames[i];
			if (wr_frame && wr_frame.processMaximoFocusCallback)
 			wr_frame.processMaximoFocusCallback();
		}
	} catch (msg) {
	}
}

//for future use
function showTreeWorking(treecontid,elemid,show)
{
	var overlay;
	if(hide == false)
	{
		overlay = getElement(elemid);
		overlay.parentNode.removeChild(overlay);

		return;
	}

	var treecontainer = getElement(treecontid);

	_width = treecontainer.offsetWidth
	_height = treecontainer.offsetHeight
	_top = treecontainer.offsetTop
	_left = treecontainer.offsetLeft

	overlay = MAINDOC.createElement("div");
	overlay.setAttribute("id",elemid);
	overlay.style.width = _width + "px"
	overlay.style.height = _height + "px"
	overlay.style.position = "absolute"
	overlay.style.background = "#dedede"
	overlay.style.top = _top + "px"
	overlay.style.left = _left + "px"

	overlay.style.filter = "alpha(opacity=50)"
	overlay.style.opacity = "0.5"
	overlay.style.mozOpacity = "0.5"

	treecontainer.appendChild(overlay);
}

// method to open a new window to display an attached document for weblogic to handle the new window focus issue
	function openURL(url)
	{
		while(url.search("#")>-1)
		{
			url=url.replace("#", "%23");
		}
		stopFocus=true;
		var newWindow = window.open(url,'newWindow','left=100,top=100,height=500,width=800,location=yes,status=yes,menubar=yes,scrollbars=yes,resizable=yes');

		if (newWindow)
		{
		    newWindow.focus();
		}

	}

