
<%-----------------------------------------------------------------------------
	Copyright (c) 2004 Actuate Corporation and others.
	All rights reserved. This program and the accompanying materials 
	are made available under the terms of the Eclipse Public License v1.0
	which accompanies this distribution, and is available at
	http://www.eclipse.org/legal/epl-v10.html
	
	Contributors:
		Actuate Corporation - Initial implementation.
-----------------------------------------------------------------------------%>
<%@ page contentType="text/html; charset=utf-8" %>
<%@ page session="false" buffer="none" %>
<%@ page import="org.eclipse.birt.report.presentation.aggregation.IFragment,
				 org.eclipse.birt.report.context.BaseAttributeBean,
				 org.eclipse.birt.report.resource.BirtResources" %>

<%-----------------------------------------------------------------------------
	Expected java beans
-----------------------------------------------------------------------------%>
<jsp:useBean id="fragment" type="org.eclipse.birt.report.presentation.aggregation.IFragment" scope="request" />
<jsp:useBean id="attributeBean" type="org.eclipse.birt.report.context.BaseAttributeBean" scope="request" />



<%-----------------------------------------------------------------------------
	Navigation bar fragment
-----------------------------------------------------------------------------%>

<TR HEIGHT="25px">
	<TD>
		<DIV id="navigationBar">

			<TABLE CELLSPACING="0" CELLPADDING="2"  CLASS="birtviewer_navbar">
				<TR><TD></TD></TR>
				<TR>
				
				
					<TD> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<TD/>
					
<!--					
					<TD WIDTH="80px"><LABEL for="gotoPage"><b><%= BirtResources.getMessage( "birt.viewer.navbar.lable.goto" )%></b></LABEL></TD>
-->					
					<TD NOWRAP><LABEL for="gotoPage" class="birtviewer_navbar_text"><b><%= BirtResources.getMessage( "birt.viewer.navbar.prompt.page" )%></b></LABEL></TD>
					<TD WIDTH="2px"/>
					<TD   WIDTH="50px">
<!--					
						<INPUT ID='gotoPage' TYPE='text' VALUE='' MAXLENGTH="8" SIZE='5' CLASS="birtviewer_navbar_input">
-->						
						<INPUT ID='gotoPage' TYPE='text' VALUE='<%= attributeBean.getReportPage( ) %>' MAXLENGTH="8" SIZE='5' CLASS="birtviewer_navbar_input">
					</TD>
					<TD WIDTH="4px"/>
					<TD  >
						<INPUT TYPE="hidden" SRC="birt/images/Go.gif" NAME='goto'
						    ALT="<%= BirtResources.getMessage( "birt.viewer.navbar.goto" )%>" 
							TITLE="<%= BirtResources.getMessage( "birt.viewer.navbar.goto" )%>" CLASS="birtviewer_clickable">
					</TD>
					<TD >
						<TABLE CELLSPACING="0" CELLPADDING="0" >
						<TR>
						<B>
						<%
							if ( attributeBean.getBookmark( ) != null )
							{
						%>
<!--						
							<%= 
								BirtResources.getMessage( "birt.viewer.navbar.prompt.one" )
							%>&nbsp;
-->
							<TD>
							<SPAN ID='pageNumber' style="display:none" class="birtviewer_navbar_text"></SPAN>
							</TD>
							<TD>
							<b>
							<SPAN ID="of" class="birtviewer_navbar_text" NOWRAP>
							<%= BirtResources.getMessage( "birt.viewer.navbar.prompt.two" )%>&nbsp;&nbsp;
							</SPAN>
							</b>
							</TD>
							<TD>
							<b>
							<SPAN ID='totalPage' class="birtviewer_navbar_text">1</SPAN>
							</b>
							</TD>
						<%
							}
							else
							{
						%>
<!--						
							<%= BirtResources.getMessage( "birt.viewer.navbar.prompt.one" )%>&nbsp;
-->
							<TD>
							<SPAN ID='pageNumber' style="display:none" class="birtviewer_navbar_text"><%= attributeBean.getReportPage( ) %></SPAN>
							</TD>
							<TD>
							<b>
							<SPAN ID="of" class="birtviewer_navbar_text" NOWRAP>
							<%= BirtResources.getMessage( "birt.viewer.navbar.prompt.two" )%>&nbsp;&nbsp;
							</SPAN>
							</b>
							</TD>
							<TD>
							<b>
							<SPAN ID='totalPage' class="birtviewer_navbar_text" >1</SPAN>
							</b>
							</TD>
						<%
							}
						%>
						</B>
						</TR>
						</TABLE>
					</TD>
					<TD WIDTH="6px"/>
	
					<TD> &nbsp;&nbsp;&nbsp;<TD/>

					<TD WIDTH="6px"/>
					
					<TD  >
						<INPUT TYPE="image" SRC="birt/images/FirstPage_disabled.gif" NAME='first'
							ALT="<%= BirtResources.getMessage( "birt.viewer.navbar.first" )%>" 
							TITLE="<%= BirtResources.getMessage( "birt.viewer.navbar.first" )%>" CLASS="birtviewer_clickable">
					</TD>
					<TD WIDTH="2px"/>
					<TD> &nbsp;<TD/>
					<TD   >
						<INPUT TYPE="image" SRC="birt/images/PreviousPage_disabled.gif" NAME='previous' 
							ALT="<%= BirtResources.getMessage( "birt.viewer.navbar.previous" )%>" 
							TITLE="<%= BirtResources.getMessage( "birt.viewer.navbar.previous" )%>" CLASS="birtviewer_clickable">
					</TD>
					<TD> &nbsp;<TD/>
					<TD />
					<TD   WIDTH="15px">
						<INPUT TYPE="image" SRC="birt/images/NextPage_disabled.gif" NAME='next'
						    ALT="<%= BirtResources.getMessage( "birt.viewer.navbar.next" )%>" 
							TITLE="<%= BirtResources.getMessage( "birt.viewer.navbar.next" )%>" CLASS="birtviewer_clickable">
					</TD>
					<TD />
					<TD> &nbsp;<TD/>
					<TD  >
						<INPUT TYPE="image" SRC="birt/images/LastPage_disabled.gif" NAME='last'
						    ALT="<%= BirtResources.getMessage( "birt.viewer.navbar.last" )%>"
							TITLE="<%= BirtResources.getMessage( "birt.viewer.navbar.last" )%>" CLASS="birtviewer_clickable">
					</TD>
					
					<TD WIDTH="8px"/>
	
					<TD> &nbsp;&nbsp;&nbsp;<TD/>
	
	
					
<!-- TOOLBAR ICONS BEGIN -->
<DIV ID="toolbar">
					<TD WIDTH="6px"/>
					<TD  >
					   <INPUT TYPE="image" NAME='toc' SRC="birt/images/Toc.gif"
					   		TITLE="<%= BirtResources.getMessage( "birt.viewer.toolbar.toc" )%>"
					   		ALT="<%= BirtResources.getMessage( "birt.viewer.toolbar.toc" )%>" CLASS="birtviewer_clickable">
					</TD>
					<TD WIDTH="6px"/>
					<TD> &nbsp;<TD/>
					<TD >
					   <INPUT TYPE="image" NAME='pdf' SRC="birt/images/pdf.gif"
					   		TITLE="<%= BirtResources.getMessage( "birt.viewer.toolbar.pdf" )%>"
					   		ALT="<%= BirtResources.getMessage( "birt.viewer.toolbar.pdf" )%>" CLASS="birtviewer_clickable">
					</TD>					
					<TD WIDTH="6px"/>
					<TD> &nbsp;<TD/>
					<TD  >
					   <INPUT TYPE="image" NAME='export' SRC="birt/images/Export.gif"
					   		TITLE="<%= BirtResources.getMessage( "birt.viewer.toolbar.export" )%>"
					   		ALT="<%= BirtResources.getMessage( "birt.viewer.toolbar.export" )%>" CLASS="birtviewer_clickable">
					</TD>
</DIV>					
<!-- TOOLBAR ICONS END -->
					
					
					<TD WIDTH="100%" />
					
					
				</TR>
			</TABLE>
		</DIV>
	</TD>
	
</TR>




<script type="text/javascript"> 
// <![CDATA[
	// Error msgs
	Constants.error.invalidPageNumber = '<%= BirtResources.getMessage( "birt.viewer.navbar.error.blankpagenum" )%>';
// ]]>
</script>

