<%--
 *
 * IBM Confidential
 *
 * OCO Source Materials
 *
 * 5724-M19
 *
 * (C) COPYRIGHT IBM CORP. 2006
 *
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 *
--%><%@ include file="../common/simpleheader.jsp" %><%
String isVisible = component.getProperty("visible");
if(componentVisible && isVisible.equals("true"))
{
	String rownum = control.getProperty("rownum");
	String text = component.getProperty("title");
	String showblank = component.getProperty("showblank");
    boolean preformattedtext = control.getProperty("preformattedtext").equalsIgnoreCase("true");
	boolean hideWhenEmpty = component.getProperty("hidewhenempty").equalsIgnoreCase("true");
	String tooltip = component.getProperty("tooltip");
	if(WebClientRuntime.isNull(tooltip))
		tooltip = component.getProperty("mxevent_desc");
	String display = "display:block;";
	String padding= "padding-left:2px;padding-top:2px;";
	int clickableState=component.getClickState();
	String designerEnabled = component.getProperty("designerenabled");
	String imageAlign = component.getProperty("imagealign");
	String displayStyle = component.getProperty("displaystyle");
	String align = component.getProperty("align");
	if(!displayStyle.equals(""))
		display="display:"+displayStyle+";";

	boolean isMasked = false;
	BoundComponentInstance boundComponent = null;
	if(component instanceof BoundComponentInstance)
	{
		boundComponent = (BoundComponentInstance)component;
		isMasked = boundComponent.isMasked();
	}
	String fieldSize = component.getProperty("size");
	if(fieldSize.equals(""))
		fieldSize="0";
	String title = component.getProperty("title");

	int size = Integer.parseInt(fieldSize);
 	if((component.isOnTableRow() && (!preformattedtext)))
	{
		if(size>40)
			size=40;
	}

	String intType= component.getProperty("inttype");
	int dataType = -1;
	if(!WebClientRuntime.isNull(intType))
		dataType=Integer.parseInt(intType);

	String tokennum = component.getProperty("tokennumber");
	String tokensep = component.getProperty("tokenseperator");

	boolean accessibleFocus = Boolean.valueOf(component.getProperty("accessiblefocus")).booleanValue();
	boolean heading = component.getProperty("useheading").equalsIgnoreCase("true") || accessibleFocus;
	boolean underline = component.getProperty("underlinelink").equalsIgnoreCase("true");
	String labelcss = component.getProperty("labelcss");
	if(!textcss.equals("") && labelcss.indexOf("text")==0)
		labelcss=textcss+" "+labelcss.substring(4);
	boolean hidelabel = component.getProperty("hidelabel").equalsIgnoreCase("true");
	boolean htmltags = component.getProperty("accepthtmltags").equalsIgnoreCase("true");
	String colorStr = "";
	String imageSrc = "";
	boolean setsFocus = Boolean.valueOf(component.getProperty("setsfocus")).booleanValue();
	String disabled="";
	String msggroup = component.getProperty("msggroup");
	String msgkey = component.getProperty("msgkey");
	if(!WebClientRuntime.isNull(msggroup) && !WebClientRuntime.isNull(msgkey))
		text = wcs.getMaxMessage(msggroup, msgkey).getMessage();

	String cancelClickBubble = "";
	if(component.isOnTableRow())
		cancelClickBubble=" cancelEvent(event); ";
	boolean onTableDetails = control.getProperty("ontabledetails").equalsIgnoreCase("true");
	String elementType = "label";
	text = WebClientRuntime.makesafevalue(text);
	if((controlType.equals("table-title") || controlType.equals("table-text")) && rownum!=null && !rownum.equals(""))
	{
		display="";
		padding="padding:0px;padding-left:1px;margin:0px;";
		if((Integer.parseInt(rownum))>=0)
		{
			text = boundComponent.getString();
			if(tooltip.equals(""))
			{
				if(text.equals("&nbsp;"))
					tooltip = "";
				else
					tooltip = text;
			}
	        if (dataType != MXFormat.DURATION && !control.getProperty("usefieldsizegroup").equals("false"))
	        {
				if(text.length()>size)
					elementType="div";
	        }
		}
		else
		{
			if(tooltip.equals(""))
			{
				if(text.equals("&nbsp;"))
					tooltip = "";
				else
					tooltip = text;
			}
		}
	}
	else
	{
		if(tooltip.equals(""))
		{
			if(text.equals("&nbsp;"))
				tooltip = "";
			else
				tooltip = text;
		}
	}


	if (text == null)
		text = "";

	boolean render = true;
	String image = component.getProperty("image");
	String tmpImage = component.getProperty("mxevent_icon");
	if(!WebClientRuntime.isNull(tmpImage))
		image=tmpImage;
	String imageFalse = component.getProperty("imagefalse");
	String mxevent = component.getProperty("mxevent");
	if(!mxevent.equals(""))
		mxevent="click";
	if(clickableState==ComponentInstance.CLICKABLE_OFF)
	{
		colorStr="color:#C0C0C0";
		disabled="disabled='disabled'";
	}
	String targetId = component.getProperty("targetid");
	//The following allows us to target an event on something else if necessary
	if(targetId.indexOf(":")==0)
		targetId=targetId.substring(1);
	else
		targetId=id;

	String eventValue = component.getProperty("eventvalue");
	String link = component.getProperty("href");

	//This is to fix a problem with table downloads (we force the component to be a direct lin to the jsp)
    if(component.getProperty("mxevent").equals("download"))
    {
		link=request.getScheme() + "://" + request.getServerName() + ":" + request.getServerPort() + request.getContextPath() + "/ui/" + System.currentTimeMillis()+ "?_tbldnld="+control.getId()+"&uisessionid="+wcs.getUISessionID();
        mxevent="";
    }

	String makeLink="";
	String accesskey = component.getProperty("accesskey");

	if (!WebClientRuntime.isNull(accesskey))
	{
		Hotkeys hotkeys = app.getHotkeys();
		hotkeys.addHotkey(accesskey, id, "click");
		tooltip += " "+accesskey;

		// Hotkeys requiring only ALT + Key have the corresponding key highlighted in the label.
		// This should be only the main nav links (BBoard, Goto, Signout, Help, etc).
		if(hotkeys.getAltState(accesskey) == true  &&  hotkeys.getCtrlState(accesskey) == false)
		{
		    char ch = hotkeys.getAccessKey(accesskey);
			int index = text.toUpperCase().indexOf(ch);
			if(index>=0)
			{
				ch = text.charAt(index);
				String labelBefore = text.substring(0,index);
				String labelAfter = text.substring(index+1);
				text = labelBefore+"<span class='text hl hlak'>"+ch+"</span>"+labelAfter;
			}

			accesskey="accesskey='"+ch+"'";
		}
	}

	String href="";
	tooltip=WebClientRuntime.removeQuotes(tooltip);
	if(!image.equals(""))
	{
		padding="";
		if(clickableState==ComponentInstance.CLICKABLE_OFF && !imageFalse.equals(""))
			image = imageFalse;
		imageSrc=IMAGE_PATH+image;
		image = "<img id='"+id+"_image' src='"+imageSrc+"' border='0' alt=\""+tooltip+"\" style='vertical-align:middle;margin:0px;margin-left:3px;margin-right:3px;'/>";
	}
	String ul= "";
	if(!link.equals("") && !isMasked)
	{
		elementType="a";
		if (app.isdoclinkweblogic())
		{
		    href="href=\"" + "javascript:openURL('" + link +"')" +  "\" ";
		}

		else
		{
		   href="href=\"" + link+"\" onmouseover=\"return noStatus();\" target=\"_blank\"";
		}
	}
	else if(!mxevent.equals("") && !isMasked)
	{
		elementType="span";
		href=" tabindex=\"0\" ";
		if(clickableState==ComponentInstance.CLICKABLE_ON)
		{
			makeLink+="cursor:pointer;";
			if((component.isOnTableRow() && (!preformattedtext)) || underline)
			{
				makeLink+="text-decoration:underline;";
				ul="ul=\"1\"";
			}
		}
	}
	else
	{
		if(controlType.equals("section") && component.getParentInstance().getType().equals("headerbar") && onTableDetails)
			cssclass="td"+cssclass;
	}
	if(designmode && !isMasked)
	{
	    // if we are a label that isn't on a dialog, give it all the designer events.  otherwise give it nothing
		if (!controlType.equalsIgnoreCase("dialog"))
		{
			componentEvents+=" onclick='return false;'";
			elementType="a";
	        href="href=\"\"";
	        cssclass = textcss+" dl";
		}
		else
		{
            componentEvents ="";
		}
	}

	// By default, labels accept HTML formatting
    if(!htmltags && !component.isOnTableRow())
	{
		text=WebClientRuntime.makesafevalue(text);
	}
	// PP: This must come AFTER makesafevalue, or <br> will be displayed literally if htmltags is false
	text = WebClientRuntime.replaceString(text, "\n", "<br>");

	if((component.isOnTableRow() || showblank.equalsIgnoreCase("true")) && (text==null || text.trim().equals("")))
		text="&nbsp;";

	if(!tokennum.equals(""))
	{
		text = WebClientRuntime.replaceString(text,tokensep," __ ");
  	    String tokens[] = text.split("__");
	  	for(int i=0;i < tokens.length;i++)
		{
	  		if(i == Integer.parseInt(tokennum))
	  		{
				text = 	tokens[i].trim();

				if(text.equals(""))
					text = "&nbsp;";
	  		}
		}
	}
	if(component.isOnTableRow() && text.equals("&nbsp;") && !image.equals(""))
		text="";

	render = render && !component.getProperty("hidelabel").equalsIgnoreCase("true");
	text=control.resolveParams(text);
	text=component.formatLabel(text);
	if(hidelabel)
		text="&nbsp;";
	String fontSize="";
	if(((!text.trim().equals("") && !text.equals("&nbsp;")) || showblank.equalsIgnoreCase("true")) || !image.equals(""))
	{
		if(accessibilityMode)
		{
			String accessiblelabelkey = component.getProperty("accessiblelabelkey");
			if(!WebClientRuntime.isNull(accessiblelabelkey))
			{
				String accessiblelabelgroup = component.getProperty("accessiblelabelgroup");
				text = wcs.getMessage(accessiblelabelgroup, accessiblelabelkey, new String[]{text});
				tooltip=text;
			}
		}
		if((controlType.equals("table-title") || controlType.equals("table-text")) && rownum!=null && !rownum.equals(""))
		{
			boolean wrapText = component.getProperty("wraptext").equalsIgnoreCase("true") && Boolean.valueOf(WebClientRuntime.getWebClientProperty("webclient.wrapreadonlycolumns","true")).booleanValue();
			if(wrapText)
			{
				title=text;
				if(text.toUpperCase().indexOf("<BR>")==-1)
					text=((Label)component).wrapText(text);
				if(!text.equals(title))
				{
					align="left";
					elementType="div";
				}
			}
			else
			{
				String wraplength = component.getProperty("wraplength");
				wraplength = WebClientRuntime.getWebClientProperty("webclient.wraplength", wraplength);
				if(WebClientRuntime.isNull(wraplength))//SAFETY
					wraplength="40";
				if(text.length()>Integer.parseInt(wraplength))
					text=text.substring(0,Integer.parseInt(wraplength)-4)+"...";
			}
			text=WebClientRuntime.makesafevalue(text);
		}

		cssclass=textcss+" "+cssclass+" "+labelcss;
		if(!cssclass.trim().equals(""))
			cssclass="class=\""+cssclass+"\"";
		if(!eventValue.equals(""))
			eventValue="ev=\""+eventValue+"\"";
		if(!mxevent.equals(""))
			mxevent="mxevent=\""+mxevent+"\"";
		if(!targetId.equals(""))
			targetId="targetid=\""+targetId+"\"";
		String noclick="";

		if(isMasked || clickableState==ComponentInstance.CLICKABLE_OFF || mxevent.equals(""))
		{
			noclick="noclick=\"1\"";
			if(clickableState==ComponentInstance.CLICKABLE_OFF)
				href="href=\"Javascript: void(0);\"";
		}
	    if(designerEnabled.equals("true"))
	    	designerEnabled="de=\"1\"";
	    else
	    	designerEnabled="";
		if(!align.equals(""))
		    align="align='"+align+"'";
		if(!hideWhenEmpty || !text.trim().equals("") || !text.trim().equals("&nbsp;"))
		{
			tooltip = WebClientRuntime.makesafevalue(tooltip);
			int controlTitleIndex = title.indexOf("{control}");
			if(controlTitleIndex>=0)
			{
				String fieldValue = WebClientRuntime.removeQuotes(((BoundComponentInstance)component).getString());
				if(fieldValue.equals(""))
					fieldValue = "__";
				tooltip=WebClientRuntime.replaceString(title, "{control}", fieldValue);
			}


		%><%if(heading){%><h1 <%if(accessibilityMode && !accessibleFocus){%>tabindex="0"<%}%> style="display:inline" title="<%=tooltip%>"><%}%><<%=elementType%> <%=align%> ctype="label" <%if(accessibilityMode && accessibleFocus){%>tabindex="0"<%}%> <%=disabled%> id="<%=id%>" <%=automationId%> <%=ul%> <%=href%> <%=componentEvents%> <%=designerEnabled%> <%=noclick%>  <%=eventValue%> <%=targetId%> <%=mxevent%> <%=accesskey%> <%=cssclass%> style="<%=display%><%=padding%>;<%=makeLink%>;<%=colorStr%>;<%=fontSize%>" title="<%=tooltip%> "><%if(imageAlign.equalsIgnoreCase("left")){%><%=image%><%}%><%=text%><%if(imageAlign.equalsIgnoreCase("right")){%><%=image%><%}%></<%=elementType%>><%if(heading){%></h1><%}%><%
		}
	}
	else
	{
		if(component.isOnTableRow())
		{	%>
		&nbsp;
	<%	}
	}
}	%><%@ include file="../common/componentfooter.jsp" %>